#include "Tep_incs.h"
#include "TepEditChar.h"
#define	ROOM			1
#define	OBJECT			2
#define HUT				3
#define SMALLBUFF		255
#undef BIGBUFF
#define BIGBUFF			4000
#define MAX_NAME_LEN	50
#define MAX_PEOPLE		6
#define MAX_OBJECTS		20
#define MAX_HUTS		5
#define EOTMARKER		"~~~"

#pragma once

typedef struct _InputRoom
{
    TepID               id;						 /* value 0 is an undefined value. These are to be unique values. */
    char               name[MAX_NAME_LEN];       /* pointer to null-termed string */
    pChar               desc;					 /* pointer to object's description data */
    TepCmds             cmd;					 /* bit fields of allowed commands of this object. */
    TepID		        rooms[4];				 /* pointer to linked list of id's for connected rooms */
    TepID		        objs[MAX_OBJECTS];       /* pointer to linked list of id's for objects in room */
	TepID				people[MAX_PEOPLE];
	TepID				dynOther[20];
    struct _InputRoom   *NEXT;					 /* pointer to the next node */
	int					type;					 /*Room or object*/
} InputRoom; /* struct _TepRoom */


typedef struct _IDKludge
{
	TepID				Room;
	TepID				Objects[MAX_OBJECTS];
	int					counter;
} IDKludge;

/*Function to Create the RoomList*/
/*Note: this encapsulates the whole shebang and is the only funtion that needs to be called*/
BOOL CreateRoomList(TepRoom **TepRoomList);

/*Function for removing tabs and newlines*/
BOOL fnRemoveTabs(char *string);

/*Function for writing temp data*/
/*Note: only used for debugging*/
BOOL fnWriteTempOutputFile(InputRoom *roomList);

/*Function for setting InputRoom default values*/
void fnInputRoomInitialize(InputRoom *inputRoom);

/*InputRoomAppending*/
BOOL fnInputRoomAppend(InputRoom **ppListRoot, InputRoom *inputRoom);

/*Function for searching InputRooms*/
InputRoom *fnInputRoomSearch(InputRoom *pRoomList, TepID searchID);

/*Function for initializing IDKludge's*/
void IDKludgeInit(IDKludge *idKludge);

/*Function for dumping "accumulated" objects into a room*/
BOOL fnFillRoomObjects(InputRoom **RoomList, IDKludge *RoomKludge);

/*Function for reading in the roomInput.txt file*/
BOOL ReadInputFile( InputRoom **RoomList);

/*Function for generating the list used in the game*/
BOOL fnGenerateGameRoomList(InputRoom *roomList, TepRoom **TepRoomList);

/*Function for Testing the RoomEdit.c code*/
void TestRoomEdit(TepRoom *tepRoomList);

/*Function for deleting InputRooms*/
BOOL fnInputRoomDelete(InputRoom **ppListRoot, InputRoom *pDeleteMe);


