# tep.mak - Matt Phillips mphillip@digipen.edu
#
# compiles and builds "the emissary of tep"
#
.SILENT:
run: pre_clean tep.exe post_clean




# BUILD MAIN EXECUTABLE
#
tep.exe : tep_main.obj TepEditCharacter.obj TepEditClue.obj TepEditCommand.obj TepEditDeath.obj TepEditTalk.obj TepEditUtils.obj RoomEdit.obj tep_lists.obj tep_printout.obj tep_story_intro.obj tep_move.obj tep_parse.obj tep_int_act.obj tep_quit.obj tep_examine.obj tep_show.obj tep_ev_collect.obj tep_greet.obj tep_insult.obj tep_sacrifice.obj tep_gameover.obj tep_charpick.obj tep_endturn.obj TepKeywordGenerator.obj AttachTalk.obj tep_newturn.obj tep_ev_organize.obj tep_compliment.obj tep_int_talk.obj tep_ask.obj 
        link /NOLOGO /debug /OUT:tep.exe tep_main.obj TepEditCharacter.obj TepEditClue.obj TepEditCommand.obj TepEditDeath.obj TepEditTalk.obj TepEditUtils.obj RoomEdit.obj tep_lists.obj tep_printout.obj tep_story_intro.obj tep_move.obj tep_parse.obj tep_int_act.obj tep_quit.obj tep_examine.obj tep_show.obj tep_ev_collect.obj tep_greet.obj tep_insult.obj tep_sacrifice.obj tep_gameover.obj tep_charpick.obj tep_endturn.obj TepKeywordGenerator.obj AttachTalk.obj tep_newturn.obj tep_ev_organize.obj tep_compliment.obj tep_int_talk.obj tep_ask.obj 





# INDIVIDUAL OBJECT FILES
#

# compile tep_main.c
tep_main.obj : tep_main.c
	cl /Zi /nologo /c tep_main.c
# -D_DEBUG

# compile TepEditUtils.c
TepEditUtils.obj : TepEditUtils.c
	cl /Zi /nologo /c TepEditUtils.c

# compile TepEditCharacter.c
TepEditCharacter.obj : TepEditCharacter.c
	cl /Zi /nologo /c TepEditCharacter.c

# compile TepEditClue.c
TepEditClue.obj : TepEditClue.c
	cl /Zi /nologo /c TepEditClue.c

# compile TepEditCommand.c
TepEditCommand.obj : TepEditCommand.c
	cl /Zi /nologo /c TepEditCommand.c

# compile TepEditDeath.c
TepEditDeath.obj : TepEditDeath.c
	cl /Zi /nologo /c TepEditDeath.c

# compile TepEditTalk.c
TepEditTalk.obj : TepEditTalk.c
	cl /Zi /nologo /c TepEditTalk.c

# compile tep_fileio.c
#tep_fileio.obj : tep_fileio.c
#	cl /Zi /nologo /c tep_fileio.c -D_DEBUG

# compile roomedit.c
RoomEdit.obj : roomedit.c
	cl /Zi /nologo /c roomedit.c

# compile tep_lists.c
tep_lists.obj : tep_lists.c
	cl /Zi /nologo /c tep_lists.c 
# -D_DEBUG

# compile tep_printout.c
tep_printout.obj : tep_printout.c
	cl /Zi /nologo /c tep_printout.c

# compile tep_story_intro.c
tep_story_intro.obj : tep_story_intro.c
	cl /Zi /nologo /c tep_story_intro.c
	
# compile tep_move.c
tep_move.obj : tep_move.c
	cl /Zi /nologo /c tep_move.c  -D_DEBUG

# compile tep_parse.c
tep_parse.obj : tep_parse.c
	cl /Zi /nologo /c tep_parse.c

# compile tep_int_act.c
tep_int_act.obj : tep_int_act.c
	cl /Zi /nologo /c tep_int_act.c

# compile tep_quit.c
tep_quit.obj : tep_quit.c
	cl /Zi /nologo /c tep_quit.c

# compile tep_examine.c
tep_examine.obj : tep_examine.c
	cl /Zi /nologo /c tep_examine.c

# compile tep_show.c
tep_show.obj : tep_show.c
	cl /Zi /nologo /c tep_show.c

# compile tep_ev_collect.c
tep_ev_collect.obj : tep_ev_collect.c
	cl /Zi /nologo /c tep_ev_collect.c

# compile tep_greet.c
tep_greet.obj : tep_greet.c
	cl /Zi /nologo /c tep_greet.c

# compile tep_insult.c
tep_insult.obj : tep_insult.c
	cl /Zi /nologo /c tep_insult.c

# compile tep_sacrifice.c
tep_sacrifice.obj : tep_sacrifice.c
	cl /Zi /nologo /c tep_sacrifice.c

# compile tep_gameover.c
tep_gameover.obj : tep_gameover.c
	cl /Zi /nologo /c tep_gameover.c

# compile tep_newturn.c
tep_charpick.obj : tep_charpick.c
	cl /Zi /nologo /c tep_charpick.c

# compile tep_newturn.c
tep_newturn.obj : tep_newturn.c
	cl /Zi /nologo /c tep_newturn.c
# -D_DEBUG

# compile tep_endturn.c
tep_endturn.obj : tep_endturn.c
	cl /Zi /nologo /c tep_endturn.c

# compile TepKeywordGenerator.c
TepKeywordGenerator.obj : TepKeywordGenerator.c
	cl /Zi /nologo /c TepKeywordGenerator.c

# compile AttachTalk.c
AttachTalk.obj : AttachTalk.c
	cl /Zi /nologo /c AttachTalk.c

# compile tep_ev_organize.c
tep_ev_organize.obj : tep_ev_organize.c
	cl /Zi /nologo /c tep_ev_organize.c

# compile tep_compliment.c
tep_compliment.obj : tep_compliment.c
	cl /Zi /nologo /c tep_compliment.c
# -D_DEBUG

# compile tep_int_talk.c
tep_int_talk.obj : tep_int_talk.c
	cl /Zi /nologo /c tep_int_talk.c

# compile tep_ask.c
tep_ask.obj : tep_ask.c
	cl /Zi /nologo /c tep_ask.c


# compile tep_proto_data.c ######## PROTOTYPE ONLY ########
tep_proto_data.obj : tep_proto_data.c
	cl /Zi /nologo /c tep_proto_data.c




# OTHER FUNCTIONS
#

# pre_clean deletes the tep executable
pre_clean:
        -del tep.exe

# post_clean deletes the tep object files
post_clean:
	-del *.obj

        
