
unsigned int CharGenderFind(TepID CharID);

/*FUNCTION:     fnListPrint
 *PARAMETERS:   _TepCurState    Used to obtain access to lists with descriptions
                TepIDUnNode     RootNode to search.
                                NOTE: To display the contents of a room without moving
                                      the cmd member of the TepParse should be DISPLAY.
 *RETURN VALUE: none
 *SIDE EFFECTS: Prints description data to the screen using fnPrintOut
 *DESCRIPTION:  This function is intended to be used by DisplayPlayerLocation
 *              to print out the descriptions of dynamic objects in a room.
 */
void fnListPrint(TepCurState *pGameState, TepIDUnNode *pListRoot);

/*FUNCTION:     DisplayPlayerLocation
 *PARAMETERS:   _TepCurState    Used to determine current location and update to new location
                TepParse        Used to determine where to move
                                NOTE: To display the contents of a room without moving
                                      the cmd member of the TepParse should be DISPLAY.
 *RETURN VALUE: Success or Failure
 *SIDE EFFECTS: Changes the game state to the new location.
                Calls PrintOut to display text for new location.
 *DESCRIPTION:  This fucntion will be passed a TepParse struct which
                will contain a direction or a location id. The function
                will determine whether or not moving in that location
                is possible. If movement in that direction is possible
                it will display text describing the new location and
                update the current game state.
 */
BOOL fnDisplayPlayerLocation(TepCurState *pGameState, TepParse msg);
