#include "TepEditCommand.h"

/* Programmer Name: Nathaniel Cleveland
 * Date Created: Feb 20th, 2001
 * Program Updated by:
 *
 * Program Description:			Loops through and fills a linked list of stuff.
 *
 * Program dependacies:			fnDefToHex, fnEditChunker
 * Takes:						TepDataString **ppListRoot,	the List Root which I'll link to
 *								char pFileToOpen[80],		the file name i want to open
 * Gives:						The BOOL value FAILURE (-1), if it doesn't work
 *								BOOL value TRUE, if it does.
 */
BOOL fnTepEditCommand(TepDataString **ppListRoot, char pFileToOpen[80])
{
	TepDataString	*pCurrNode = *ppListRoot;				/* point to the first item in the list*/
    TepDataString	*pNewNode = NULL;						/* pointer to the newly created node */
	FILE			*FileHandle = NULL;						/* handle to the file I'm going to open */
	BOOL			bErrorCheck = TRUE;						/* varible to hold bool results */
	char			cpString[ARRAYSIZE];					/* string filled with file chunks */
	char			cpMemString[LONG_ARRAYSIZE];			/* used for long strings that aren't appreate for an array */

	memset(cpMemString, 0, LONG_ARRAYSIZE);					/* zero out the string(s) */
	memset(cpString, 0, ARRAYSIZE );

	/********************************************************************************/
	/**** 1. malloc mem for the list root, fail if we can't CALLER NOW DOES THIS ****/
	/********************************************************************************/

	/****************************************************************************/
	/**** 2. open the file, do a quick read to make sure the file is there ******/
	/****************************************************************************/
	if( (FileHandle  = fopen(pFileToOpen, "r" )) == NULL )
	{
      printf("Failed to open the file\n");
	  return FAILURE;
	}


	/*********************************/
	/**** 3. fill in the stuct(s) ****/
	/*********************************/
	/* loop thru and fill the structs. Stop filling whenever we encounter the string END OF FILE */
	for( ; ; )
	{

		pNewNode = calloc(1, sizeof(TepDataString));					/* allocate memory for the new node */
//printf("0x%X\n",&pNewNode);
		if(pNewNode == NULL)										/* check for failure */
		{
			printf("failed to calloc memory\n");
			return FAILURE;
		}

 //       if (pCurrNode == NULL)
//		    *ppListRoot = pCurrNode = pNewNode;
//printf("\n0x%X\n0x%X\n",&pNewNode, &pCurrNode);
		pNewNode->NEXT = NULL;										/* set the next node pointer to NULL */

		if(fnEditChunker(cpString, FileHandle, '\t') == FALSE)		/* get the next chunk of info, check for END OF FILE */
		{
//			printf("break\n");
			break;
		}/* end if */

//		printf("%s\n", cpString);

		/* fill in the id, check for the use of #defs */
		if(atoi(cpString) == 0)										/* If this is a #def name, call fnDefToHex */
		{	//		printf("at\n");												/*  */
			pNewNode->id = fnDefToHex(cpString);					/* translate the #def name to its number */
		//	printf("HERE\n");
		}/* end if */
		else														/* If it is just a number use that */
		{
			pNewNode->id = atoi(cpString);							/* call atoi to convert it to int */
		}/* end else */

//	if(pNewNode->id == TEP_COMMAND |COM_GO)
//	{
//		printf("This is GO!!\n");
//	}

//		memset(cpString, 0, strlen(cpString) );						/* zero out the string for the next call */

		/* get data chunk */
		if(fnEditChunker(cpMemString, FileHandle, '\n') == FALSE)	/* get the next chunk of info, check for END OF FILE */
		{
			break;
		}

//		printf(">>%s\n", cpMemString);

		/* fill in the data */
		pNewNode->data = calloc( strlen(cpMemString) + 1, sizeof(char));/* calloc mem for the string */
//printf("90\n");
		if(pNewNode->data == NULL)										/* check for error in calloc */
		{
			printf("calloc didn't alloc mem for the data.\n");
			return FAILURE;
		}
//printf("91\n");											/* copy the string to the memory alloced string */
		pNewNode->data = memmove(pNewNode->data, cpMemString, strlen(cpMemString) );
//printf("92\n");
		/* Test the node(s) */

		//printf("0x%x\n", pNewNode->id);
//		printf("%s\n", pNewNode->data);
		//printf("NEXT->%08X\n", pNewNode->NEXT);
//printf("92.5\n");
		/* set this node to the list */
//printf("\n0x%X\n0x%X\n",pNewNode, pCurrNode);
		pNewNode->NEXT = *ppListRoot;
		*ppListRoot = pNewNode;
//printf("93\n");
		/* point CurrNode at this node */
//		pCurrNode = pNewNode;
	}/* end for */


	if( fclose(FileHandle) != 0)
	{
		printf("damn file wouldn't close");
	}

	return TRUE;
}/* End fnTepEditDeath */

/****************** DEBUG MAIN ******************/
/*
int main(void)
{
	char inputArray[255];
	BOOL bCheckBool;
	TepDataString *pListRoot=NULL;

	pListRoot = calloc(1, sizeof(TepChar));

	while(1)
	{
		if(gets(inputArray) == NULL)
			break;

		if(inputArray == 0)
			break;

		bCheckBool = fnTepEditCommand(&pListRoot, "CommandContent.txt");
		if(bCheckBool == FALSE)
		{
			printf("\nFailed\n");
		}
		else
		{
			printf("\nDidn't fail\n");
		}
	}
	free(pListRoot);
	return 0;
}
*/
/*
int main ( int argc, char *argv[], char *envp[])
{
    pTepDataString pListRoot = NULL;

    if (argc > 1)
    {
        BOOL bCheckBool;

        pListRoot = calloc(1, sizeof(TepDataString));
        bCheckBool = fnTepEditCommand(&pListRoot, argv[1]);

        if(bCheckBool == FAILURE || bCheckBool == FALSE)
        {
            printf("\nFailed\n");
        }
        else
        {
            printf("\nDidn't fail\n");
        }
    }
    else
    {
        printf("Usage:\n  TepEditClue <filename> [outputfile]\n    Where <filename> is the name of the file to be processed.\n    Outputfile is the name of the file to write to.\n\n");
    }

    if (pListRoot != NULL)
    {
        FILE *ioStream = NULL;

        if (argc > 2)
        {
            ioStream = fopen(argv[2], "w" );
        }
        else
        {
            ioStream = fopen("tepCommand.dat", "w");
        }

        if (ioStream != NULL)
        {
            fnTepEditWriteFile(TEP_COMMAND, pListRoot->NEXT, ioStream);
            fclose(ioStream);
        }
        else
        {
            printf("There was an error in opening the output file.\n");
        }

        //fnTepCharDelete(&pListRoot, NULL);
    }

    return 0;
}
*/
