#include "tep_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include "TepEditUtils.h"
#include "tep_lists.h"
#include "tepkeywordgenerator.h"

pChar fnToUpperStr(pChar cpString)
{
	pChar pcChar = cpString;

	if (pcChar != NULL)
		for (;;)
		{
			if (pcChar != '\0')
			{
				if (*pcChar >= 'a' && *pcChar <= 'z')
					*pcChar = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"[*pcChar - 'a'];
				pcChar++;
			}
			else
				break;
		}

	return cpString;
}

/*FUNCTION:		fnToUpperStr
 *PARAMETERS:	char *cpString				The string you want converted to all caps
 *RETURN VALUE: TepID						A pointer to the string you just changed.
 *SIDE EFFECTS:	Sets a string to all upper case.
 *DESCRIPTION:	Loops around and makes a string uppercase. uses toupper.
*/
char *fnToUpperStr2(char *cpString)
{
	int i;

	for(i = 0 ; cpString[i] != 0 ; i++)
	{
		cpString[i] = toupper(cpString[i]);
	}
	return	cpString;
}


BOOL TepKeywordGenerator(TepCurState *pGameState, TepDataString	*pCommandList, TepChar *pCharList, TepClueData *pClueList, TepRoom *pRoomList)
{
	/* print out the current values passed */
/*	{
		printf("\nPointers passed to keywordGenerator\n");
		printf("pCommandList = %8x\n", pCommandList);
		printf("pCharList    = %8x\n", pCharList);
		printf("pClueList    = %8x\n", pClueList);
		printf("pRoomList    = %8x\n", pRoomList);
	}
*/


	/* for all of the commands */
	if( pCommandList != NULL )
	{
//		printf("\nCommand keywords: ");
		for( ; pCommandList != NULL ; pCommandList = pCommandList->NEXT )
		{
			//		printf("0x%x\n%s\n\n", pCommandList->id , pCommandList->data);
			pChar	cpString = NULL;
//			printf(".");
			cpString = calloc(strlen(pCommandList->data) + 1, 1);
			if(cpString == NULL)
			{
				printf("failure to calloc on Command keywords\n");
				return FALSE;
			}
			strcpy(cpString, pCommandList->data);

			//printf("Append\n");
			fnTepDataStringAppend(&(pGameState->keywords), pCommandList->id ,  fnToUpperStr2(cpString));

		}/* end for */
		printf("\n");
	}


	/* load character keywords */
	if( pCharList != NULL )
	{
//		printf("\nCharacter keywords: ");
		for( ; pCharList != NULL ;pCharList = pCharList->NEXT )
		{
			//printf("0x%x\n%s\n\n", pCharList->id , pCharList->name);
			pChar	cpString = NULL;
//			printf(".");
			cpString = calloc(strlen(pCharList->name) +1, 1);
			if(cpString == NULL)
			{
				printf("failure to calloc on Character keywords\n");
				return FALSE;
			}
			strcpy(cpString, pCharList->name);

			fnTepDataStringAppend(&(pGameState->keywords), pCharList->id , fnToUpperStr2(cpString));
		}/* end for */
		printf("\n");
	}


	/* for all of the clues */
	if( pClueList != NULL )
	{
//		printf("\nClue keywords: ");
		for( ; pClueList != NULL ;pClueList = pClueList->NEXT )
		{
			char * cpString = NULL;

			//printf("0x%x\n%s\n\n",pClueList->id , pClueList->keyword);
//			printf(".");
			cpString = calloc(strlen(pClueList->keyword) + 1, 1);
			if(cpString == NULL)
			{
				printf("failure to calloc on 3\n");
				return FALSE;
			}
			strcpy(cpString, pClueList->keyword);
			//printf("%s\n%s\n", cpString, pClueList->keyword);
			fnTepDataStringAppend(&(pGameState->keywords), pClueList->id , fnToUpperStr2(cpString));
		} //end for
		printf("\n");
	}


	/* for all of the rooms */
	if( pRoomList != NULL )
	{
//		printf("\nRoom keywords: ");
		for( ; pRoomList != NULL ;pRoomList = pRoomList->NEXT )
		{
			pChar	cpString = NULL;
			//	printf("0x%x\n%s\n\n", pRoomList->id , pRoomList->name);
//			printf(".");

			cpString = calloc(strlen(pRoomList->name) + 1, 1);
			if(cpString == NULL)
			{
				printf("failure to calloc on 4\n");
				return FALSE;
			}
			strcpy(cpString, pRoomList->name);

			//printf("append\n");
			fnTepDataStringAppend(&(pGameState->keywords), pRoomList->id , fnToUpperStr2(cpString));
		}/* end for */
		printf("\n");
	}


#if 0
		/* print out the current keyword list */
		{
			TepDataString *pData;

			printf("\nCurrent keywords\n");
			for(pData = pGameState->keywords; pData != NULL; pData = pData->NEXT)
			{
				printf("%s\t%x\n", pData->data, pData->id);
			}
			printf("\n");
		}
#endif

    return TRUE;
}
/************ Debug Main Function ************/
/*
int main()
{
	TepDataString	*pCommandList = NULL;	// debug
	TepChar			*pCharList = NULL;		// debug
	TepClueData		*pClueList = NULL;		// debug
	TepRoom *pRoomList = NULL;				// debug
    int i = 0;
	TepCurState GameState;
	GameState.keywords = NULL;

	// comand
	pCommandList = calloc(1, sizeof(TepDataString));
	if(pCommandList == NULL)
	{
		printf("failed to calloc mem for command string list root");
		return FALSE;
	}

	if(fnTepEditCommand(&pCommandList, "CommandContent.txt") == FAILURE )
	{
		printf("\n Failed at command\n");
		return FALSE;
	}

	// chars
	pCharList = calloc(1, sizeof(TepChar));
	if(pCharList == NULL)
	{
		printf("failed to calloc mem for char string list root");
		return -1;
	}

	if(fnTepEditCharacter(&pCharList, "CharacterContent.txt") == FAILURE )
	{
		printf("\nFailed at character\n");
		return -1;
	}

	// clue
	pClueList = calloc(1, sizeof(TepClueData));
	if(pClueList == NULL)
	{
		printf("failed to calloc mem for clue string list root");
		return -1;
	}


	if(fnTepEditClue(&pClueList, "ClueContent.txt") == FAILURE )
	{
		printf("\nFailed at clue\n");
		return -1;
	}
	// get passed the nate bug //
	pCommandList = pCommandList->NEXT;
	pCharList = pCharList->NEXT;
	pClueList = pClueList->NEXT;

	// call
	if(TepKeywordGenerator(&GameState, pCommandList, pCharList, pClueList, pRoomList) == FALSE)
	{
		printf("FALSE\n");
	}
	else
	{
		for( ; GameState.keywords != NULL; GameState.keywords = GameState.keywords->NEXT, i++ )
		{
			printf("0x%x\n%s\n\n", GameState.keywords->id, GameState.keywords->data);
		}

	}

	return 0;
}
*/
