#include "tep_incs.h"

TepChar *fnPickRandBadChar( TepCurState *pGameState )
{
    TepIDUnNode *pID = NULL;            /* pointer to a id list */
    int iCount, iRand;

    /* count the available murderers */
    pID = pGameState->killersList;
    for( iCount = 0; pID != NULL; iCount++, pID = pID->NEXT );

    /* pick a random murderer */
	if( iCount > 0 )
	{
		/* fill iRand with an appropriate random value */
		iRand = rand() % iCount;

		/* pick the murderer... */
		pID = pGameState->killersList;
		for( iCount = 0; iCount < iRand; iCount++, pID = pID->NEXT );
	}

    /* return the matching character pointer */
    return fnTepCharSearch( pGameState->liveList, pID->NODE );
}




TepChar *fnPickRandGoodChar( TepCurState *pGameState )
{
    TepChar *pID = NULL;              /* pointer to a char list */
    TepChar *pGoodChar = NULL;          /* pointer to a good char */
    int iCount, iRand, i;

    /* count the available victims */
    pID = pGameState->liveList;
    for( iCount = 0; pID != NULL; iCount++, pID = pID->NEXT );

    /* pick a random victim - loop if the victim is one of the killers */
	if( iCount > 0 )
	{
		do
		{
			/* fill iRand with an appropriate random value */
			iRand = rand() % iCount;

			/* pick the victim... */
			pID = pGameState->liveList;
			for( i = 0; i < iRand; i++, pID = pID->NEXT );

			/* find the matching character */
			pGoodChar = fnTepCharSearch( pGameState->liveList, pID->id );

		}while( fnTepIDSearch( pGameState->killersList, pGoodChar->id ) != NULL || pGoodChar->id == (TEP_CHARACTER | CHAR_SHEROESHA) );
	}

    /* return the character pointer */
    return pGoodChar;
}




