#include "tep_incs.h"


/********************************************************************************************/
/*TepChar List Functions*/

/*FUNCTION:     fnTepCharSearch
 *PARAMETERS:   TepChar                 *pListRoot  Used as the starting point for the list search
 *              TepID                   searchID    Search for this parameter
 *RETURN VALUE: Pointer to the node in the list that the search matches
 *SIDE EFFECTS: None
 *DESCRIPTION:  This function searches for a node in the list corresponding to the given node pointer.
*/
/*
TepChar* fnTepCharSearch(TepChar *pListRoot, TepID searchID)
{
    TepChar *pCurrNode;

    for(pCurrNode = pListRoot; pCurrNode != NULL; pCurrNode = pCurrNode->NEXT)
    {
        if((pCurrNode->id) == searchID)
        {
            return pCurrNode;
        }
    }

    return NULL;
}

/**** TEP CONV DATA *****************************/

/*FUNCTION:     fnTepConvDataSearch
 *PARAMETERS:   TepConvData             *pListRoot  Used as the starting point for the list search
 *              TepID                   searchID    Search for this parameter
 *RETURN VALUE: Pointer to the node in the list that the search matches
 *SIDE EFFECTS: None
 *DESCRIPTION:  This function searches for a node in the list corresponding to the given node pointer.
*/
/*
TepConvData *fnTepConvDataSearch(TepConvData *pListRoot, TepID searchID)
{
    TepConvData *pCurrNode;

    for(pCurrNode = pListRoot; pCurrNode != NULL; pCurrNode = pCurrNode->NEXT)
    {
        if((pCurrNode->id) == searchID)
        {
            return pCurrNode;
        }
    }
    return NULL;
}
/********************************************************************************************/



BOOL fnGreet(TepCurState *pGameState, TepID ID_Character)
{
    TepChar     *pTep_Char = NULL;                  /* The character being greeted */
    TepConvData *pTep_Conv = NULL;                  /* pointer the the first possible response */

    /* Search for the character */
    pTep_Char = fnTepCharSearch(pGameState->liveList, ID_Character);

    /* check for any errors */
    if(pTep_Char == NULL)
    {
        return FAILURE;
    }

    /* Search for a character's info struct aka TepChar */
    pTep_Conv = fnTepConvDataSearchRand(pTep_Char->conv, TEP_TALK | TALK_HELLO, 0);

    /* check for any errors */
    if(pTep_Conv == NULL)
    {
        return FAILURE;
    }

    /* print out one of their responses */
    fnPrintOut(NOPAUSE, NULL,NULL,1, pTep_Conv->details);

    return SUCCESS;
}

/*
int main(void)
{
    TepCurState GameState;
    TepID ID_Character = 0;
    char inputArray[255];

    while(1)
    {
        if(gets(inputArray) == NULL)
            break;

        if(inputArray == 0)
            break;

        fnGreet(&GameState, ID_Character);

    }

    return 0;
}
*/