#include "tep_incs.h"
/***************************************************LOAD GAME FUNCTION DEFINITIONS ***************************************************/

/* The head load honcho is defined! */
BOOL fnLoadGame(TepCurState *gameState)
{
	/* This is the load game function. */
	
	FILE *stream;								/* My file stream for file I/O */
	int i, j;									/* Generic counters */
	int fileSize = 0;							/* Holds the size of a .tsv file for error checking. */
	int iFileCounter = 0;						/* Keeps track of the offset (in bytes) into the save file */
	unsigned char cPlayerInput;					/* A receptacle for the player's input */
	char *fileName[MAX_SAVE_GAMES];
	
	/* NUMBER_OF_CHUNKS - 3 refers to the fact that the TPSV format identifier, the NOFI name of file subchunk, */
	/* and the TOSA time of save subchunk are all not necessary to load. */
	LOADFUNC jumpTable[NUMBER_OF_CHUNKS - 3] = {
			fnLoadTULE,
			fnLoadCURM,
			fnLoadKILS,
			fnLoadLILT,
//			fnLoadNAME,		Struck from game
			fnLoadEVAG,
//			fnLoadEVGE,		Struck from game
//			fnLoadOEVA,		Struck from game
//			fnLoadOEVG,		Struck from game
//			fnLoadCUVI,		Struck from game
			fnLoadCUMU,
			fnLoadPADE,
//			fnLoadCUDE,		Struck from game
//			fnLoadROID,		Struck from game
			fnLoadROPE,
			fnLoadROBJ};
		
		
		/* For every possible saved game, initialize the name of each. */
		for (i = 0; i < MAX_SAVE_GAMES; ++i)
		{
			fileName[i] = (char *)malloc( 13*sizeof(unsigned char) );
			sprintf(fileName[i], "save\\tepSave%i.tsv", i);
		}
		
		printf("\n-------------------------------CHOOSE A LOAD SLOT-------------------------------");
		printf("Saved Game                                              Time Game Was Saved     ");
		printf("--------------------------------------------------------------------------------");
		
		/* Scan all ten .tsv files and display their names and times of saving. */
		if ( (fnScanSave(&stream, fileName, &fileSize)) == FALSE)
		{
			printf("Failed to scan and display save files!");
			return FALSE;
		}
		
		/* Get player input. */
		printf("CHOOSE A SLOT TO LOAD FROM.  'X' RETURNS TO GAME>");
		
		cPlayerInput = getchar();
		fflush(stdin);
		
		if (cPlayerInput == 'X' || cPlayerInput == 'x')
		{
			return FALSE;//printf("Bailout."); //Call InterpetAction
		}
		else if ( (cPlayerInput >= '0') && (cPlayerInput <= '9') )
		{
			unsigned char cPlayerConfirm;		/* A receptacle for the player's confirmation. */
			
			/* Make sure the player really wants to load the game... */
			printf("Would you really like to load <file%cName>? (Y to confirm)", cPlayerInput);
			cPlayerConfirm = getchar();
			fflush(stdin);
			
			
			/* If the player confirms his decision then load the game from the specified slot. */
			if (cPlayerConfirm == 'Y' || cPlayerConfirm == 'y')
			{
				unsigned char bByte[4];			/* Holds the four letter format identifiers */
				
				
				/* Open the file the player selected, so that we can read the dynamic game data from it. */
				if ( (stream = fopen(fileName[atoi(&cPlayerInput)], "rb") ) == NULL)
				{
					printf("Failed to open file!\n");
					return FALSE;
				}
				
				
				/* Get the file pointer past the TPSV file format identifier, the NOFI name file name of file data, and the TOSA time of */
				/* save data. */
				/* If the file is actually a .tsv Tep Save File, then continue reading data. */
				fread(bByte, sizeof(char), 4, stream);
				if ( (bByte[0] == 'T') &&
					(bByte[1] == 'P') &&
					(bByte[2] == 'S') &&
					(bByte[3] == 'V') )
				{
					
					iFileCounter += sizeof(char)*4;			/* Increment the file pointer to reflect us reading into the file */
					
					/* Read in the NOFI subchunk format identifier */
					fread(bByte, sizeof(char), 4, stream);
					if ( (bByte[0] == 'N') &&
						(bByte[1] == 'O') &&
						(bByte[2] == 'F') &&
						(bByte[3] == 'I') )
					{
						char *cString;					/* Holds the name and date strings */
						int iNumObjects;				/* Stores how many objects are in this subchunk */
						int iCheckFileOffset;			/* Used for error checking */
						int iLocalCount;				/* Generic counters */
						
						
						iFileCounter += sizeof(char)*4;			/* Increment the file pointer to reflect us reading into the file */
						
						
						/* Read in the number of objects; allocate the necessary memory to store the string */
						fread(&iNumObjects, sizeof(char), 4, stream);
						iFileCounter += sizeof(char)*4;			/* Increment the file pointer to reflect us reading into the file */
						cString = calloc((iNumObjects + 1), sizeof(char));
						
						
						/* Read in the "predicted" file offset, for error checking. */
						fread(&iCheckFileOffset, sizeof(int), 1, stream);
						iFileCounter += sizeof(int)*1;			/* Increment the file pointer to reflect us reading into the file */
						
						
						/* Read in the actual string: the name of the saved game */
						for (iLocalCount = 0; iLocalCount < iNumObjects; ++iLocalCount)
						{
							fread(&cString[iLocalCount], sizeof(char), 1, stream);
							iFileCounter += sizeof(char)*1;			/* Increment the file pointer to reflect us reading into the file */
						}
						cString[iLocalCount] = 0;
						
						
						fread(bByte, sizeof(char), 4, stream);
						if ( (bByte[0] == 'T') &&
							(bByte[1] == 'O') &&
							(bByte[2] == 'S') &&
							(bByte[3] == 'A') )
						{
							char *cString;			/* Holds the name and date strings */
							int iNumObjects;		/* Stores how many objects are in this subchunk */
							int iCheckFileOffset;	/* Used for error checking */
							int iLocalCount;		/* A generic counter */
							
							iFileCounter += sizeof(char)*4;			/* Increment the file pointer to reflect us reading into the file */
							
							
							/* Read in the number of objects; allocate the necessary memory to store the string */
							fread(&iNumObjects, sizeof(char), 4, stream);
							iFileCounter += sizeof(char)*4;			/* Increment the file pointer to reflect us reading into the file */
							cString = calloc((iNumObjects + 1), sizeof(char));
							
							
							/* Read in the "predicted" file offset, for error checking. */
							fread(&iCheckFileOffset, sizeof(int), 1, stream);
							iFileCounter += sizeof(int)*1;			/* Increment the file pointer to reflect us reading into the file */						
							
							
							/* Read in the actual string */
							for (iLocalCount = 0; iLocalCount < iNumObjects; ++iLocalCount)
							{
								fread(&cString[iLocalCount], sizeof(char), 1, stream);
								iFileCounter += sizeof(char)*1;			/* Increment the file pointer to reflect us reading into the file */
							}
							cString[iLocalCount] = 0;
							
						}
						else
						{
							printf("Corrupted save file (failed on Time of Save data)!  Cannot load this file.\n\n");
							return FALSE;
						}
						
						free(cString);
					}
					else
					{
						printf("Corrupted save file (failed on name of file)!  Cannot load this file.\n\n");
						return FALSE;
					}
				}
				else
				{
					printf("Corrupted save file (failed on TPSV format identifier)!  Cannot load this file.\n\n");
					return FALSE;
				}

				/* kill previous game's data */
				fnEndGame( gameState ); //end game deletes all but the map and keywords for the map and commands

				/* set up the player struct - init to NULL */
				gameState->player = malloc( sizeof( TepPlayer ) );
				memset( gameState->player, 0, sizeof( TepPlayer ) );
				
				/* The file pointer now points to the format identifier of the first "dynamic game data" subchunk. Load them all. */
				for (j = 0; j < (NUMBER_OF_CHUNKS - 3); ++j)
				{
					if (jumpTable[j](stream, &iFileCounter, gameState) == FALSE)
					{
						printf("Failed to load jump table entry %i.\n", j);
						return FALSE;
					}
				}
				
				/* complete the load here - fill in all the static data */
				fnLoadStaticData( gameState );
			}
			else
			{
				//printf("Oh Lord, we'd best loop back to the start..."); //call the LoadGame function again
			}
			
		}
		else
		{
			printf("Invalid input.");
			//Now I will call the SaveGame or LoadGame function.
		}
		
		fclose(stream);
		
		for (i = 0; i < MAX_SAVE_GAMES; ++i)
		{
			free(fileName[i]);
		}

		printf("Game successfully loaded.  Press any key to continue.\n");

		while(!_kbhit())								/* Pause the game until the programmer whacks any key, for debugging. */				
		{
			;
		}								
		_getch();		

		return TRUE;
		
}


/* This function will write a header file for any .tsv subchunk.  It also checks to make sure that the format identifiers come in */
/* the expected order, and that the expected file offset and actual file offset at each subchunk are equivalent.  Thus, it relies */
/* on the SaveGame function to correctly initialize these values. */
BOOL fnHeaderRead(FILE *stream, char const iIdentifier[4], unsigned long *iNumObjects, unsigned long *iFileOffset)
{
	char cBuffer[5];					/* Used for error checking */
	unsigned long iExpectedOffset;		/* Used for error checking */

	/* Make sure the format identifiers are in the correct order */
	if ( fread(cBuffer, sizeof(char), 4, stream) != 4)
	{
		printf("Error reading the identifier of subchunk ""%s""'s header.\n", iIdentifier);
		return FALSE;
	}
	*iFileOffset += sizeof(char)*4;
	cBuffer[4] = 0;						/* NULL terminate the four character identifier. */

	if (strcmp(cBuffer, iIdentifier) != 0)
	{
		printf("Failure to load file; format identifiers do not match up.\n");
		return FALSE;
	}
	
	/* Fill in the iNumObjects; the number of upcoming objects to load */
	if ( fread(iNumObjects, sizeof(unsigned long), 1, stream) != 1)
	{
		printf("Error reading the number of objects of subchunk ""%s""'s header.\n", iIdentifier);
		return FALSE;
	}
	*iFileOffset += sizeof(unsigned long)*1;


	/* Here we increment the file pointer by the sizeof(int) in advance, so that the value corresponds to the */
	/* true offset (in bytes, from the beginning of the .svt file) that the actual game data is at. */
	*iFileOffset += sizeof(unsigned long)*1;
	if ( fread(&iExpectedOffset, sizeof(unsigned long), 1, stream) != 1)
	{
		printf("Error reading the file offset of subchunk ""%s""'s header.\n", iIdentifier);
		return FALSE;
	}
	if (*iFileOffset != iExpectedOffset)
	{
		printf("Failure to load file, file offset and expected file offset do not match.\n");
		return FALSE;
	}

	return TRUE;

}

/* The number of turns left is then loaded */
BOOL fnLoadTULE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	unsigned long iNumExpectedObjects = 0;		/* For error checking, the number of objects expected to be read in. */
	unsigned short TurnsLeft = 0;

	if ( fnHeaderRead(stream, "TULE", &iNumExpectedObjects, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}

	/* Read the actual data */
	if ( (fread(&TurnsLeft, sizeof(unsigned short), iNumExpectedObjects, stream)) != iNumExpectedObjects )
	{
		printf("Failed to read TULE from file!\n");
		return FALSE;
	}
	*iFileOffset += sizeof(unsigned short);
	
	/* Load the actual data */
	gameState->turnsLeft = TurnsLeft;
	
	return TRUE;
}

/* Current Room data */
BOOL fnLoadCURM(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	unsigned long iNumExpectedObjects = 0;		/* For error checking, the number of objects expected to be read in. */
	/* Get the tepID of the current room */
	unsigned long CurRoom = 0;


	if ( fnHeaderRead(stream, "CURM", &iNumExpectedObjects, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}

	/* Read the actual data */
	if ( (fread(&CurRoom, sizeof(unsigned long), iNumExpectedObjects, stream)) != iNumExpectedObjects )
	{
		printf("Failed to read CURM from file!\n");
		return FALSE;
	}
	*iFileOffset += sizeof(unsigned long);
	/* Load the actual data */
	gameState->currentRoom = fnTepRoomSearch( gameState->FullMap, CurRoom );

	return TRUE;
}

/* Killer List data */
BOOL fnLoadKILS(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	unsigned int iLocalCount = 0;		/* A generic counter */
	unsigned long iNumKillers = 0;		/* For error checking, the number of objects expected to be read in. */
	unsigned long *KillerList;


	if ( fnHeaderRead(stream, "KILS", &iNumKillers, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}

	/* Get the number of characters on the killers list */
	KillerList = calloc(iNumKillers, sizeof(unsigned long));

	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumKillers; ++iLocalCount)
	{
		if ( (fread(&KillerList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write KILS to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Load the actual data */
	for (iLocalCount = 0; iLocalCount < iNumKillers; ++iLocalCount)
	{
		fnTepIDAppend(&gameState->killersList, *(KillerList + iLocalCount));
	}

	/* Cleanup */
	free(KillerList);

	return TRUE;
}

/* Live List data */
BOOL fnLoadLILT(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	int iNumLongs = 0;				/* The number of unsigned longs to be loaded */
	unsigned long *LiveList;
	int iNumLive = 0;				/* The number of live characters */


	if ( fnHeaderRead(stream, "LILT", &iNumLongs, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of characters on the live list */
	LiveList = calloc(iNumLongs, sizeof(unsigned long));

	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumLongs; ++iLocalCount)
	{
		if ( (fread(&LiveList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write LILT to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Get the number of live characters */
	iNumLive = LiveList[0];

	/* Load the tepIDs of each character on the live list */
	for (iLocalCount = 1; iLocalCount < iNumLongs; )
	{
		TepID character = 0;
		TepCharLikePlayer like = 0;
		uChar complimentCount = 0;
		pTepWhack whackListP = NULL;
		TepIDUnNode *clueListP = NULL;
		int numSuspicion = 0;				/* The number of suspicion indices for a given character */
		int numAttachClues = 0;				/* The number of clues attached to a character */
		int count = 0;						/* Generic counter */


		character = LiveList[iLocalCount];
		/**/
		if( character == (TEP_CHARACTER | CHAR_SHEROESHA) )
		{
			iLocalCount = iLocalCount;
		}
		++iLocalCount;
		like = (unsigned char)LiveList[iLocalCount];
		++iLocalCount;
		complimentCount = (unsigned char)LiveList[iLocalCount];
		++iLocalCount;


		numSuspicion = LiveList[iLocalCount];
		++iLocalCount;

		for (count = 0; count < numSuspicion; ++count)
		{
			TepID suspect;
			USHORT value;


			value = (unsigned short)LiveList[iLocalCount];
			++iLocalCount;
			suspect = (TepID)LiveList[iLocalCount];
			++iLocalCount;

			fnTepWhackAppend(&whackListP, suspect, value);
		}

		numAttachClues = LiveList[iLocalCount];
		++iLocalCount;

		for (count = 0; count < numAttachClues; ++count)
		{
			TepID clueID;


			clueID = LiveList[iLocalCount];
			++iLocalCount;

			fnTepIDAppend(&clueListP, clueID);
		}



		fnTepCharAppend( &gameState->liveList, character, NULL, NULL, NULL, whackListP, clueListP, NULL, like, NULL, NULL, complimentCount );
		
		whackListP = NULL;
	}


	/* Cleanup */
	free(LiveList);

	return TRUE;
}

/* Character's name data */
BOOL fnLoadNAME(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	//This is not, and probably won't be, implemented.

	return TRUE;
}

/* Evidence Against data - clue ID then char ID */
BOOL fnLoadEVAG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	int iNumEvidenceAgainst = 0;
	unsigned long *EvidenceAgainstList;


	if ( fnHeaderRead(stream, "EVAG", &iNumEvidenceAgainst, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of objects in the evidence against */
	EvidenceAgainstList = calloc(iNumEvidenceAgainst, sizeof(unsigned long));

	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumEvidenceAgainst; ++iLocalCount)
	{
		if ( (fread(&EvidenceAgainstList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write EVAG to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Load the objects in the evidence against */
	for (iLocalCount = 0; iLocalCount < iNumEvidenceAgainst; )
	{
		TepID clue, character, where;

		clue = EvidenceAgainstList[iLocalCount];
		++iLocalCount;
		character = EvidenceAgainstList[iLocalCount];
		++iLocalCount;
		where = EvidenceAgainstList[iLocalCount];
		++iLocalCount;

		fnTepEvidenceAppend( &gameState->player->evidenceGeneric, clue, character, where );
	}


	/* Cleanup */
	free(EvidenceAgainstList);

	return TRUE;
}

/* Evidence Generic data */
BOOL fnLoadEVGE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	int iNumEvidenceGeneric = 0;	
	unsigned long *EvidenceGenericList;


	if ( fnHeaderRead(stream, "EVGE", &iNumEvidenceGeneric, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of objects on the evidence generic list */
	EvidenceGenericList = calloc(iNumEvidenceGeneric, sizeof(unsigned long));

	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumEvidenceGeneric; ++iLocalCount)
	{
		if ( (fread(&EvidenceGenericList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to read EVGE from file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Load the tepIDs of each object on the evidence generic list */
	for (iLocalCount = 0; iLocalCount < iNumEvidenceGeneric; ++iLocalCount)
	{
		printf("Evidence generic object #%i is tepID %i\n", iLocalCount, EvidenceGenericList[iLocalCount]);
	}


	/* Cleanup */
	free(EvidenceGenericList);

	return TRUE;
}

/* Old Evidence Against STRUCK FROM GAME */
BOOL fnLoadOEVA(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *OldEvidenceAgainstList;
	int iNumOldEvidenceAgainst = 0;



	if ( fnHeaderRead(stream, "OEVA", &iNumOldEvidenceAgainst, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of characters on the old evidence against list */
	OldEvidenceAgainstList = calloc(iNumOldEvidenceAgainst, sizeof(unsigned long));

	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceAgainst; ++iLocalCount)
	{
		if ( (fread(&OldEvidenceAgainstList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to read OEVA from file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Load the actual data */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceAgainst; ++iLocalCount)
	{
		printf("Old Evidence Against object %i is tepID %i\n", iLocalCount, OldEvidenceAgainstList[iLocalCount]);
	}



	/* Cleanup */
	free(OldEvidenceAgainstList);

	return TRUE;
}

/* Old Evidence Generic NOT */
BOOL fnLoadOEVG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *OldEvidenceGenericList;
	int iNumOldEvidenceGeneric = 0;



	if ( fnHeaderRead(stream, "OEVG", &iNumOldEvidenceGeneric, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of objects on the old evidence generic list */
	OldEvidenceGenericList = calloc(iNumOldEvidenceGeneric, sizeof(unsigned long));


	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceGeneric; ++iLocalCount)
	{
		if ( (fread(&OldEvidenceGenericList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write OEVG to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Load the tepIDs of each object on the old evidence generic list */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceGeneric; ++iLocalCount)
	{
		printf("Evidence generic object #%i is tepID %i.\n", iLocalCount, OldEvidenceGenericList[iLocalCount]);
	}

	/* Cleanup */
	free(OldEvidenceGenericList);

	return TRUE;
}

/* Current Victim STRUCK FROM GAME */
BOOL fnLoadCUVI(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	int iNumCurrentVictims = 0;
	unsigned long *CurrentVictimList;


	if ( fnHeaderRead(stream, "CUVI", &iNumCurrentVictims, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of characters on the current victim list */
	CurrentVictimList = calloc(iNumCurrentVictims, sizeof(unsigned long));


	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumCurrentVictims; ++iLocalCount)
	{
		if ( (fread(&CurrentVictimList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to read CUVI to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Get the tepIDs of each character on the victim list */
	for (iLocalCount = 0; iLocalCount < iNumCurrentVictims; ++iLocalCount)
	{
		printf("Current victim #%i has tepID %i.\n", iLocalCount, CurrentVictimList[iLocalCount]);
	}

	/* Cleanup */
	free(CurrentVictimList);

	return TRUE;
}

/* Current Murder data */
BOOL fnLoadCUMU(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	unsigned int iLocalCount = 0;			/* A generic counter */
	unsigned long *CurrentMurderList;
	unsigned int iNumCurrentMurder = 0;


	if ( fnHeaderRead(stream, "CUMU", &iNumCurrentMurder, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}

	/* Get the number of characters on the current murder list */
	CurrentMurderList = calloc(iNumCurrentMurder, sizeof(unsigned long));


	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumCurrentMurder; ++iLocalCount)
	{
		if ( (fread(&CurrentMurderList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to read CUMU from file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Load the tepIDs of each object in the current murder data */
	for (iLocalCount = 0; iLocalCount < iNumCurrentMurder; ++iLocalCount)
	{
		TepID murd, vict;

		murd = CurrentMurderList[iLocalCount];
		iLocalCount++;

		vict = CurrentMurderList[iLocalCount];
		iLocalCount++;

		fnTepCurMurderAppend( &gameState->currentMurder, vict, murd, NULL );
	}


	/* Cleanup */
	free(CurrentMurderList);

	return TRUE;
}

/* Past Deaths data */
BOOL fnLoadPADE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	unsigned int iLocalCount = 0;			/* A generic counter */
	unsigned int iNumPastDeaths = 0;
	unsigned long *PastDeaths;
	TepCurMurder *murdListP = gameState->currentMurder;


	if ( fnHeaderRead(stream, "PADE", &iNumPastDeaths, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}

	/* Get the number of past deaths - SIZE OF PAST DEATHS!!! */
	PastDeaths = calloc(iNumPastDeaths, sizeof(unsigned long));

	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumPastDeaths; ++iLocalCount)
	{
		if ( (fread(&PastDeaths[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to read PADE to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Load the tepIDs of each past death */
	for (iLocalCount = 0; iLocalCount < iNumPastDeaths; murdListP = murdListP->NEXT)
	{
		TepID deathID, locID;
		unsigned long clueCount = 0, count = 0;
		TepClueData *clueListP = NULL;


		deathID = PastDeaths[iLocalCount];
		iLocalCount++;

		locID = PastDeaths[iLocalCount];
		iLocalCount++;

		clueCount = PastDeaths[iLocalCount];
		iLocalCount++;

		for( count = 0; count < clueCount; count++ )
		{
			TepID clueID;

			clueID = PastDeaths[iLocalCount];
			iLocalCount++;

			fnClueDataAppend( &clueListP, clueID, 0, NULL, NULL );
		}

		fnTepDeathAppend( &murdListP->death, deathID, locID, NULL, NULL, clueListP );

		clueListP = NULL;
	}

	/* Cleanup */
	free(PastDeaths);

	return TRUE;
}

/* Current Deaths data NOT */
BOOL fnLoadCUDE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *CurrentDeathsList;
	int iNumCurrentDeaths = 0;


	if ( fnHeaderRead(stream, "CUDE", &iNumCurrentDeaths, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of characters on the killers list */
	CurrentDeathsList = calloc(iNumCurrentDeaths, sizeof(unsigned long));


	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumCurrentDeaths; ++iLocalCount)
	{
		if ( (fread(&CurrentDeathsList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write CUDE to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0; iLocalCount < iNumCurrentDeaths; ++iLocalCount)
	{
		printf("Current Death object #%i has tepID %i.\n", iLocalCount, CurrentDeathsList[iLocalCount]);
	}


	/* Cleanup */
	free(CurrentDeathsList);

	return TRUE;
}

/* Room ID  NOT */
BOOL fnLoadROID(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *RoomIDList;
	int iNumRoomID = 0;


	if ( fnHeaderRead(stream, "ROID", &iNumRoomID, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of characters on the killers list */
	RoomIDList = calloc(iNumRoomID, sizeof(unsigned long));


	/* Read the actual data */
	for (iLocalCount = 0; iLocalCount < iNumRoomID; ++iLocalCount)
	{
		if ( (fread(&RoomIDList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to read ROID from file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0; iLocalCount < iNumRoomID; ++iLocalCount)
	{
		printf("Room ID object #%i has tepID %i.\n", iLocalCount, RoomIDList[iLocalCount]);
	}


	/* Cleanup */
	free(RoomIDList);

	return TRUE;
}

/* Room People data */
BOOL fnLoadROPE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *RoomPeopleList;
	int iNumRoomPeople = 0;


	if ( fnHeaderRead(stream, "ROPE", &iNumRoomPeople, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of characters on the killers list */
	RoomPeopleList = calloc(iNumRoomPeople, sizeof(unsigned long));


	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumRoomPeople; ++iLocalCount)
	{
		if ( (fread(&RoomPeopleList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to read ROPE from file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0; iLocalCount < iNumRoomPeople; )
	{
		TepID roomID, charID;
		TepDynRoom *droomP = NULL;
		TepRoom *roomP = NULL;


		charID = RoomPeopleList[iLocalCount];
		/*
		if( charID == (TEP_CHARACTER | CHAR_SHEROESHA) )
		{
			iLocalCount = iLocalCount;
		}*/
		iLocalCount++;

		roomID = RoomPeopleList[iLocalCount];
		iLocalCount++;

		/* do we already have dynamic data for this room? */
		if( ( droomP = fnTepDynRoomSearch( gameState->mapLite, roomID ) ) == NULL )
		{
			TepIDUnNode *peepListP = NULL;

			/* add the character id to an id list */
			fnTepIDAppend( &peepListP, charID );

			/* get a pointer to the assoc. room */
			roomP = fnTepRoomSearch( gameState->FullMap, roomID );

			/* add the dyn room to the list */
			fnTepDynRoomAppend( &gameState->mapLite, roomID, roomP, peepListP, NULL );
		}
		/* we do! yay! so append the new data to the old */
		else
		{
			fnTepIDAppend( &droomP->people, charID );
		}
	}


	/* Cleanup */
	free(RoomPeopleList);

	return TRUE;
}

/* Room Object data */
BOOL fnLoadROBJ(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *RoomObjectList;
	int iNumRoomObjects = 0;


	if ( fnHeaderRead(stream, "ROBJ", &iNumRoomObjects, iFileOffset) == FALSE)
	{
		printf("fnHeaderRead failed.\n");
		return FALSE;
	}
	/* Get the number of characters on the killers list */
	RoomObjectList = calloc(iNumRoomObjects, sizeof(unsigned long));


	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumRoomObjects; ++iLocalCount)
	{
		if ( (fread(&RoomObjectList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write ROBJ to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}

	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0; iLocalCount < iNumRoomObjects; ++iLocalCount)
	{
		TepID roomID, objID;
		TepDynRoom *droomP = NULL;
		TepRoom *roomP = NULL;


		objID = RoomObjectList[iLocalCount];
		iLocalCount++;

		roomID = RoomObjectList[iLocalCount];
		iLocalCount++;

		/* do we already have dynamic data for this room? */
		if( ( droomP = fnTepDynRoomSearch( gameState->mapLite, roomID ) ) == NULL )
		{
			TepIDUnNode *objListP = NULL;

			/* add the character id to an id list */
			fnTepIDAppend( &objListP, objID );

			/* get a pointer to the assoc. room */
			roomP = fnTepRoomSearch( gameState->FullMap, roomID );

			/* add the dyn room to the list */
			fnTepDynRoomAppend( &gameState->mapLite, roomID, roomP, NULL, objListP );
		}
		/* we do! yay! so append the new data to the old */
		else
		{
			fnTepIDAppend( &droomP->objs, objID );
		}		
	}


	/* Cleanup */
	free(RoomObjectList);

	return TRUE;
}

/* added by matt phillips to fill in the static data that is not saved in a saved game */
BOOL fnLoadStaticData( TepCurState *pGameState )
{
	BOOL			fRet;
	TepChar			*pFullCharList = NULL;
	TepDBConvData	*pTepDBConv = NULL;
	TepDeath		*pFullDeathList = NULL;
	TepClueData		*pFullClueList = NULL;



	/* load characters *********/
    fRet = fnTepEditCharacter(&pFullCharList, IPS_CHARACTER);
	if (fRet != TRUE)
	{
		printf("Failed to load character content\n");
		return FALSE;
	}

	/* create keywords for all of the characters */
	fRet = TepKeywordGenerator(pGameState, NULL, pFullCharList, NULL, NULL);

	/* copy static character data to the current live list */
	{
		TepChar *pLive, *pMatch;

		for( pLive = pGameState->liveList; pLive != NULL; pLive = pLive->NEXT )
		{
			if( ( pMatch = fnTepCharSearch( pFullCharList, pLive->id ) ) != NULL )
			{
				pLive->name = pMatch->name;
				pLive->desc = pMatch->desc;
				pLive->locations = pMatch->locations;
				pLive->ident = pMatch->ident;

				pMatch->name = NULL;
				pMatch->desc = NULL;
				pMatch->locations = NULL;
			}
		}
	}


	/* free up the full char list now that we're through with it */
	fnTepCharDelete( &pFullCharList, NULL );



	/* Load Talk/Conv ************/
	fRet = fnTepEditTalk(&pTepDBConv, IPS_CONVERSATION);
	if(fRet != TRUE)
	{
		printf("Failed to load talk content\n");
		return FALSE;
	}

	/* attach the conversations to the live characters - and attach all the generic conversations */
	fRet = fnAttachTalk(pTepDBConv, pGameState->liveList, &pGameState->genConv);

	/* free up the memory taken by pTepDBConv */
	{
		TepDBConvData *pTemp;

		while( pTepDBConv != NULL )
		{
			pTemp = pTepDBConv;
			pTepDBConv = pTepDBConv->NEXT;

			free( pTemp );
		}
	}	


	/* load deaths ************/
	if( fnTepEditDeath(&pFullDeathList, IPS_DEATH) == FAILURE )
	{
		printf("Could not load the death list.");
		return FAILURE;
	}

	/* load clues *************/
	if( fnTepEditClue(&pFullClueList, IPS_CLUE) == FAILURE )
	{
		printf("Could not load the clue list.");
		return FAILURE;
	}

	/* fill in the death descriptions - and clue data */
	{
		TepCurMurder *pMurd;
		TepDeath *pDMatch;
		TepClueData *pClue, *pCMatch;

		/* loop through all murders/deaths */
		for( pMurd = pGameState->currentMurder; pMurd != NULL; pMurd = pMurd->NEXT )
		{
			/* get the matching death desc */
			if( ( pDMatch = fnTepDeathSearch( pFullDeathList, pMurd->death->id ) ) != NULL )
			{
				pMurd->death->desc = pDMatch->desc;

				pDMatch->desc = NULL;
			}

			/* now fill in the clue data */
			for( pClue = pMurd->death->clues; pClue != NULL; pClue = pClue->NEXT )
			{
				/* find the matching data */
				if( ( pCMatch = fnClueDataSearch( pFullClueList, pClue->id, 0 ) ) != NULL )
				{
					pClue->details = pCMatch->details;
					pClue->keyword = pCMatch->keyword;
					pClue->attachedto = pCMatch->attachedto;

					pCMatch->details = NULL;
					pCMatch->keyword = NULL;
				}
			}

			/* now create the keywords for the current death's clues */
			TepKeywordGenerator( pGameState, NULL, NULL, pMurd->death->clues, NULL );
		}
	}/* done filling deaths/clues */

	/* free up the memory from the static death/clue lists */
    fnTepDeathDelete( &pFullDeathList, NULL );
    fnClueDataDelete( &pFullClueList, NULL );

	return TRUE;
}
