#include "tep_incs.h"

/*********************************************** Function Definitions *************************************************/
/************************************* fnTepFileManage interfaces with them all ***************************************/
BOOL fnTepFileManage(TepCurState *gameState)
{
	unsigned char cInput;
	
	for(;;)
	{
		printf("\n--------------------------------CHOOSE AN OPTION--------------------------------");
		printf("\n\n\n");
		printf("1)Save Game\n2)Load Game\n3)Erase Game\n4)Back to \"The Emissary of Tep\"\n\n>");
		
		cInput = fgetc(stdin);
		fflush(stdin);
		if ((cInput > '0') && (cInput < '6'))
		{
			switch(atoi(&cInput))
			{
			case 1:
				{
					fnSaveGame(gameState);
					break;
				}
			case 2:
				{
					fnLoadGame(gameState);
					break;
				}
			case 3:
				{
					fnEraseGame();
					break;
				}
			case 4:
				{
					/* pass a false look */
					TepParse Parse;
					Parse.Command = COM_DISPLAY;
					Parse.Reserved = gameState->currentRoom->id;

					fnDisplayPlayerLocation(gameState, Parse);
					return TRUE;
				}
			}
		}
		else
		{
			printf("Invalid input.>");
			continue;
		}
	}
	return FALSE;
}

/*********************************************** fnEraseGame Definition *************************************************/
BOOL fnEraseGame()
{
	int cPlayerInput, iSizeOfFile, i;
	char *fileName[MAX_SAVE_GAMES];
	FILE *stream;

	/* For every possible saved game, initialize the name of each. */
	//change this to read in the name of each file.
	for (i = 0; i < MAX_SAVE_GAMES; ++i)
	{
		fileName[i] = (char *)malloc( MAX_CHARACTERS_IN_GAME_FILENAME*sizeof(unsigned char) );
		sprintf(fileName[i], "save\\tepSave%i.tsv", i);
	}

	printf("\n-----------------------------CHOOSE A SLOT TO ERASE-----------------------------");
	printf("Saved Game                                              Time Game Was Saved     ");
	printf("--------------------------------------------------------------------------------");


	/* Scan all ten .tsv files and display their names and times of saving. */
	if ( (fnScanSave(&stream, fileName, &iSizeOfFile)) == FALSE)
	{
		printf("Failed to scan and display save files!");
		return FALSE;
	}

	/* Get player input. */
	printf("CHOOSE A SLOT TO ERASE.  'X' RETURNS TO MENU>");

	cPlayerInput = getchar();
	fflush(stdin);

	if (cPlayerInput == 'X' || cPlayerInput == 'x')
	{
		printf("Bailout."); //Call fnTepFileManage
	}
	else if ( (cPlayerInput >= '0') && (cPlayerInput <= '9') )
	{
		unsigned char cPlayerConfirm;		/* A receptacle for the player's confirmation. */

		/* Make sure the player really wants to save the game... */
		printf("Would you really like to erase <file%cName> (Y to confirm)", cPlayerInput);
		cPlayerConfirm = getchar();
		fflush(stdin);

		/* If the player confirms his decision then save the game to the specified slot. */
		if (cPlayerConfirm == 'Y' || cPlayerConfirm == 'y')
		{
			char bByte;
			//int filenum = atoi(&cPlayerInput);

			stream = fopen(fileName[cPlayerInput - '0'], "wb"); //atoi(cPlayerInput)

			/* Determine the size of the file */
			for (iSizeOfFile = 0; fread(&bByte, sizeof(char), 1, stream) != 0; ++iSizeOfFile)
			{
				;
			}
						
			/* Rewind to beginning of save file. */
			fseek(stream, 0, SEEK_SET);

			fwrite(NULL, sizeof(char), iSizeOfFile, stream);
			
			/* Cleanup */
			fclose(stream);
			for(i = 0; i < MAX_SAVE_GAMES; ++i)
			{
				free( (void *)fileName[i]);
			}
		}
	}

	return TRUE;
}


/*********************************************** fnSaveGame Definitions *************************************************/
/* The head save honcho is defined! */
BOOL fnSaveGame(TepCurState *gameState)
{

	//I lied this is actually the save game function.

	FILE *stream = NULL;								/* My file stream for file I/O */
	int i = 0;											/* A generic counter*/
	int fileSize = 0;									/* Holds the size of a .tsv file in bytes. */
	unsigned char cPlayerInput = 0;						/* A receptacle for the player's input */
	SAVEFUNC jumpTable[NUMBER_OF_CHUNKS] = {
		fnSaveTPSV,
		fnSaveNameOfFile,							/* Jump table of functions for all data */
		fnSaveTimeOfSave,							/* types to be saved */
		fnSaveTULE,
		fnSaveCURM,
		fnSaveKILS,
		fnSaveLILT,
		fnSaveEVAG,
		fnSaveCUMU,
		fnSavePADE,
//		fnSaveNAME,		Struck from game.
//		fnSaveEVGE,		Struck from game.	
//		fnSaveOEVA,		Struck from game.
//		fnSaveOEVG,		Struck from game.
//		fnSaveCUVI,		Struck from game.
//		fnSaveCUDE,		Struck from game.
//		fnSaveROID,		Struck from game.
		fnSaveROPE,
		fnSaveROBJ};


	char *fileName[MAX_SAVE_GAMES];


	/* For every possible saved game, initialize the name of each. */
	//change this to read in the name of each file.
	for (i = 0; i < MAX_SAVE_GAMES; ++i)
	{
		fileName[i] = (char *)malloc( MAX_CHARACTERS_IN_GAME_FILENAME*sizeof(unsigned char) );
		sprintf(fileName[i], "save\\tepSave%i.tsv", i);
	}


	printf("\n-------------------------------CHOOSE A SAVE SLOT-------------------------------");
	printf("Saved Game                                              Time Game Was Saved     ");
	printf("--------------------------------------------------------------------------------");


	/* Scan all ten .tsv files and display their names and times of saving. */
	if ( (fnScanSave(&stream, fileName, &fileSize)) == FALSE)
	{
		printf("Failed to scan and display save files!");
		return FALSE;
	}

	/* Get player input. */
	printf("CHOOSE A SLOT TO SAVE TO.  'X' RETURNS TO GAME>");

	cPlayerInput = getchar();
	fflush(stdin);

	if (cPlayerInput == 'X' || cPlayerInput == 'x')
	{
		printf("Bailout."); //Call InterpetAction
	}
	else if ( (cPlayerInput >= '0') && (cPlayerInput <= '9') )
	{
		unsigned char cPlayerConfirm;		/* A receptacle for the player's confirmation. */

		/* Make sure the player really wants to save the game... */
		printf("Would you really like to overwrite <file%cName> with a new save? (Y to confirm)", cPlayerInput);
		cPlayerConfirm = getchar();
		fflush(stdin);

		/* If the player confirms his decision then save the game to the specified slot. */
		if (cPlayerConfirm == 'Y' || cPlayerConfirm == 'y')
		{
			int iFileCounter = 0;				/* The file counter keeps track of where bit fields are being placed */
												/* in the .tsv file. */
			int iLocalCount;					/* a generic counter */


			/* Open the file the player selected, so that we can write the dynamic game data to it. */
			if ( (stream = fopen(fileName[atoi(&cPlayerInput)], "wb") ) == NULL)
			{
				printf("Failed to open file!\n");
				return FALSE;
			}

			/* For each chunk of data, write the header file for the chunk, followed by the actual chunk data. */
			/* Increment iFileCounter so that the file offset data for each header is on hand and ready to write. */
			for (iLocalCount = 0; iLocalCount < NUMBER_OF_CHUNKS; ++iLocalCount)
			{
				if (jumpTable[iLocalCount](stream, &iFileCounter, gameState) == FALSE)
				{
					printf("fnSaveGame failed on jump table entry %i.\n", iLocalCount);
					return FALSE;
				}
			}


			printf("Game saved successfully.\n");

		}
		else
		{
			printf("Oh Lord, we'd best loop back to the start..."); //call the SaveGame function again
		}
		
	}
	else
	{
		printf("Invalid input.");
		//Now I will call the SaveGame or LoadGame function.
	}

	/* Clean up */
	fclose(stream);

	for(i = 0; i < MAX_SAVE_GAMES; ++i)
	{
		free( (void *)fileName[i]);
	}

	return TRUE;

}


BOOL fnScanSave(FILE **stream, char *fileName[MAX_SAVE_GAMES], int *fileSize)

{
	int i;						/* A generic counter */

	/* Open every .svt file; if it does not already exist, create a blank .svt file. */
	for (i = 0; i < MAX_SAVE_GAMES; ++i)
	{
		unsigned char bByte[4];							/* Memory buffer to analyze data */
		int iSizeOfFile;								/* Size in bytes of the save file */

		/* Open all ten save slot files. */
		if ( (*stream = fopen(fileName[i], "rb") ) == NULL)
		{
			/* If the file does not exist, create a blank one. */
			fopen(fileName[i], "wb");
			
			/* If we still can't open the file, then bail out. */
			if ( (*stream = fopen(fileName[i], "rb") ) == NULL)
			{
				printf("Error opening a save file (or creating a blank save file)!\n");
				return FALSE;
			}
			fclose(*stream);
		}

		/* Determine the size of the file */
		for (iSizeOfFile = 0; fread(bByte, sizeof(char), 1, *stream) != 0; ++iSizeOfFile)
		{
			;
		}

		*fileSize = iSizeOfFile;

		/* Rewind to beginning of save file. */
		fseek(*stream, 0, SEEK_SET);

		/* If the file is actually a .tsv Tep Save File, then display pertinent data. */
		fread(bByte, sizeof(char), 4, *stream);
		if ( (bByte[0] == 'T') &&
			(bByte[1] == 'P') &&
			(bByte[2] == 'S') &&
			(bByte[3] == 'V') )
		{
			
			/* Read in the NOFI subchunk format identifier */
			fread(bByte, sizeof(char), 4, *stream);
			if ( (bByte[0] == 'N') &&
				(bByte[1] == 'O') &&
				(bByte[2] == 'F') &&
				(bByte[3] == 'I') )
			{
				char *cString;					/* Holds the name and date strings */
				int iNumObjects;				/* Stores how many objects are in this subchunk */
				int iCheckFileOffset;			/* Used for error checking */
				int iLocalCount, jLocalCount;	/* Generic counters */
								
				
				/* Read in the number of objects; allocate the necessary memory to store the string */
				fread(&iNumObjects, sizeof(char), 4, *stream);
				cString = calloc((iNumObjects + 1), sizeof(char));


				/* Read in the "predicted" file offset, for error checking. */
				fread(&iCheckFileOffset, sizeof(int), 1, *stream);
				

				/* Read in the actual string: the name of the saved game */
				for (iLocalCount = 0; iLocalCount < iNumObjects; ++iLocalCount)
				{
					fread(&cString[iLocalCount], sizeof(char), 1, *stream);
				}
				cString[iLocalCount] = 0;
				printf("%i) %s", i, cString);

				for (jLocalCount = 0; jLocalCount < (FORMATSPACING - (iLocalCount + 3)); ++jLocalCount)
				{
					printf(" ");
				}
				
				
				fread(bByte, sizeof(char), 4, *stream);
				if ( (bByte[0] == 'T') &&
					(bByte[1] == 'O') &&
					(bByte[2] == 'S') &&
					(bByte[3] == 'A') )
				{
					char *cString;			/* Holds the name and date strings */
					int iNumObjects;		/* Stores how many objects are in this subchunk */
					int iCheckFileOffset;	/* Used for error checking */
					int iLocalCount;		/* A generic counter */
					
					
					/* Read in the number of objects; allocate the necessary memory to store the string */
					fread(&iNumObjects, sizeof(char), 4, *stream);
					cString = calloc((iNumObjects + 1), sizeof(char));
					
					
					/* Read in the "predicted" file offset, for error checking. */
					fread(&iCheckFileOffset, sizeof(int), 1, *stream);
					
					
					/* Read in the actual string */
					for (iLocalCount = 0; iLocalCount < iNumObjects; ++iLocalCount)
					{
						fread(&cString[iLocalCount], sizeof(char), 1, *stream);
					}
					cString[iLocalCount] = 0;
					printf("%s\n", cString);
					
				}
				else
				{
					printf("Corrupted save file!  Cannot load this file.\n\n");
				}
				
				free(cString);
			}
			else
			{
				printf("Corrupted save file!  Cannot load this file.\n\n");
			}
			
			
		}
		else
		{
			printf("%i) Blank Save %i\n\n", i, i);
		}
		
	}

	return TRUE;
}

/* This function will write a header file for any .tsv subchunk. */
BOOL fnHeaderWrite(FILE *stream, char const iIdentifier[4], unsigned long iNumObjects, unsigned long *iFileOffset)
{
	/* Write the subchunk's format identifier */
	if ( fwrite(iIdentifier, sizeof(char), 4, stream) != 4)
	{
		printf("Error writing the identifier of subchunk ""%s""'s header.\n", iIdentifier);
		return FALSE;
	}
	*iFileOffset += sizeof(char)*4;
	
	/* Write the number of objects that will appear in the subchunk */
	if ( fwrite(&iNumObjects, sizeof(unsigned long), 1, stream) != 1)
	{
		printf("Error writing the number of objects of subchunk ""%s""'s header.\n", iIdentifier);
		return FALSE;
	}
	*iFileOffset += sizeof(unsigned long)*1;

	/* Here we increment the file pointer by the sizeof(int) in advance, so that the value corresponds to the */
	/* true offset (in bytes, from the beginning of the .svt file) that the actual game data is at. */
	*iFileOffset += sizeof(unsigned long)*1;
	if ( fwrite(iFileOffset, sizeof(unsigned long), 1, stream) != 1)
	{
		printf("Error writing the file offset of subchunk ""%s""'s header.\n", iIdentifier);
		return FALSE;
	}

	return TRUE;

}


/* The file format identifier is written first */
BOOL fnSaveTPSV(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	if ( (fwrite(&"TPSV", sizeof(char), 4, stream)) != 4 )
	{
		printf("Failed to write TPSV to file!\n");
		return FALSE;
	}
	*iFileOffset += (sizeof(char))*4;
	
	return TRUE;
}

/* Now the name the user designated for this save file */
BOOL fnSaveNameOfFile(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	char *nameOfSavedGame;			/* Holds the name of the saved game */
	int nameLength;					/* Holds the length of the name */
	int count;						/* A local counter */


	nameOfSavedGame = calloc(MAX_CHARACTERS_IN_GAME_NAME, sizeof(char));
	//Get the name of the file from the player; test to make sure it's within MAX_CHARACTERS_IN_GAME_NAME range.

	printf("\nPlease name the saved game.  Press Enter when you're done.\n");

	fgets(nameOfSavedGame, MAX_CHARACTERS_IN_GAME_NAME, stdin);
	fflush(stdin);
	/* Remove the '\n' character from the input string. Replace the NULL character. */
	nameLength = strlen(nameOfSavedGame);
	*(nameOfSavedGame + nameLength - 1) = 0;


	if ( fnHeaderWrite(stream, "NOFI", nameLength, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Now write the actual data */
	for (count = 0; count < nameLength; ++count)
	{
		if ( (fwrite(&nameOfSavedGame[count], sizeof(char), 1, stream)) != 1 )
		{
			printf("Failed to write NOFI to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(char);
	}
	

	//Error checking: make sure the file counter adds up.

	/* Cleanup */
	free(nameOfSavedGame);

	return TRUE;
}

/* The time the game was saved */
BOOL fnSaveTimeOfSave(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{

	time_t CurrentTime;				/* Holds the time at the moment the game was saved. */
	char *CurTimeString = NULL;		/* Holds a printable string of the current time */
	int stringLength = 0;			/* Holds the length of the printable string */
	int count = 0;					/* Generic counter */


	/* allocate enough memory for my string of the current time */
	CurTimeString = calloc(30, sizeof(char));

	/* Grab the current time and format it to a string */
	if (time(&CurrentTime) == -1)
	{
		printf("Failed to get the current time.  Your computer sucks!\n");
		return FALSE;
	}
	strcpy( CurTimeString, (ctime(&CurrentTime)) );


	/* Write the header */
	stringLength = strlen(CurTimeString);
	if ( fnHeaderWrite(stream, "TOSA", stringLength, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (count = 0; count < stringLength; ++count)
	{
		if ( (fwrite(&CurTimeString[count], sizeof(char), 1, stream)) != 1 )
		{
			printf("Failed to write TOSA to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(char);
	}


	/* Cleanup */
	free(CurTimeString);
	

	return TRUE;
}

/* The number of turns left is then saved */
BOOL fnSaveTULE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	/* Get the turns left */
	unsigned short TurnsLeft = gameState->turnsLeft;


	if ( fnHeaderWrite(stream, "TULE", 1, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	if ( (fwrite(&TurnsLeft, sizeof(unsigned short), 1, stream)) != 1 )
	{
		printf("Failed to write TULE to file!\n");
		return FALSE;
	}
	*iFileOffset += sizeof(unsigned short);
	
	
	return TRUE;
}

/* Current Room data */
BOOL fnSaveCURM(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	/* Get the tepID of the current room */
	unsigned long CurRoom = gameState->currentRoom->id;


	if ( fnHeaderWrite(stream, "CURM", 1, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	if ( (fwrite(&CurRoom, sizeof(unsigned long), 1, stream)) != 1 )
	{
		printf("Failed to write CURM to file!\n");
		return FALSE;
	}
	*iFileOffset += sizeof(unsigned long);

	return TRUE;
}

/* Killer List data; each unsigned long is a character ID. */
BOOL fnSaveKILS(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	int iNumKillers = 0;
	TepIDUnNode *pKillersList = gameState->killersList;
	unsigned long *KillerList;


	/* Get the number of characters on the killers list */
	for (iNumKillers = 0; pKillersList != NULL  ; ++iNumKillers, pKillersList = pKillersList->NEXT)
	{
		;
	}
	KillerList = calloc(iNumKillers, sizeof(unsigned long));


	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0, pKillersList = gameState->killersList; iLocalCount < iNumKillers; ++iLocalCount, pKillersList = pKillersList->NEXT)
	{
		*(KillerList + iLocalCount) = pKillersList->NODE;
	}

	if ( fnHeaderWrite(stream, "KILS", iNumKillers, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumKillers; ++iLocalCount)
	{
		if ( (fwrite(&KillerList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write KILS to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(KillerList);

	return TRUE;
}

/* Past Deaths data */
/* First integer is the death id, second integer is room id of the death location, third integer is the number of clues for this death,  */
/* following integers are the clues. */
BOOL fnSavePADE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *PastDeaths;
	TepCurMurder *tepCurMurder;		/* A pointer to the current murder; grab the data from here */
	int anotherLocalCount = 0;		/* this is just a generic counter */
	
	tepCurMurder = gameState->currentMurder;			/* Point to first murder node */

	PastDeaths = calloc(400, sizeof(unsigned long));				/* MALLOC A KLUDGED AMOUNT OF MEMORY */


	/* Set tepCurMurder to point to the first node of the list */
	tepCurMurder = gameState->currentMurder;

	/* Get the tepIDs of each the relevant data */
	for (; tepCurMurder != NULL; tepCurMurder = tepCurMurder->NEXT)
	{	
		TepClueData *clueP;				/* Pointer to a clue struct */
		int count;						/* A generic counter */


		/* Get the ID of the death */
		*(PastDeaths + iLocalCount) = tepCurMurder->death->id;
		++iLocalCount;
		/* Get the ID of the location of death */
		*(PastDeaths + iLocalCount) = tepCurMurder->death->location;
		++iLocalCount;
		/* Get the number of clues */
		for (count = 0, clueP = tepCurMurder->death->clues; clueP->NEXT != NULL; clueP = clueP->NEXT, ++count)
		{
			;
		}
		/* Record the number of clues */
		*(PastDeaths + iLocalCount) = count;
		++iLocalCount;
		/* Record the ids of each clue, in order */
		for (clueP = tepCurMurder->death->clues; clueP->NEXT != NULL; clueP = clueP->NEXT)
		{
			*(PastDeaths + iLocalCount) = clueP->id;
			++iLocalCount;
		}
	}

	if ( fnHeaderWrite(stream, "PADE", iLocalCount, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (anotherLocalCount = 0; anotherLocalCount < iLocalCount; ++anotherLocalCount)
	{
		if ( (fwrite(&PastDeaths[anotherLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write PADE to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(PastDeaths);

	return TRUE;
}


/* Live List data. First integer is the number of live characters (N).  Then, for each character, the next integer is the character, ID, */
/* followed by an integer that is the trust index in the character, followed by an integer that is the complimentCounter of the character, */
/* that is followed by the number of suspicion indices for this character (S), followed by S pairs of integers, where the */
/* first integer is the suspicion value and the second integer is the character ID the value pertains to, followed by the number of */
/* attached clues C, followed by C number of clue IDs. */
BOOL fnSaveLILT(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	int anotherLocalCount = 0;		/* Another generic counter */
	TepChar *pLiveChar = gameState->liveList;
	unsigned long *LiveList;
	int iNumLive = 0;				/* The number of live characters */


	/* Get the number of characters on the live list */
	for (iLocalCount = 0, iNumLive = 0; pLiveChar != NULL  ; ++iNumLive, pLiveChar = pLiveChar->NEXT)
	{
		;
	}


	LiveList = calloc(iNumLive*iNumLive*4, sizeof(unsigned long));	/* For each live character, store his or her ID, trust index, */
																	/* complimentCounter, number of suspicion of indices, We're just */
																	/* going to malloc a heap of memory cuz this is a last minute KLUDGE */

	/* Record the number of live characters */
	*(LiveList + iLocalCount) = iNumLive;
	++iLocalCount;



	/* Get the data of each character on the live list */
	for (pLiveChar = gameState->liveList; pLiveChar != NULL; pLiveChar = pLiveChar->NEXT)
	{
		int suspicionCount = 0;				/* The number of suspicion indices of a given character */
		TepWhack *whackP = NULL;			/* A pointer to a character's whack list */
		TepIDUnNode *clueAttached = NULL;	/* A pointer to the list of clues that's attached to this character */		
		int iNumClues = 0;					/* The number of attached clues for this character */


		/* Get the character ID */
		*(LiveList + iLocalCount) = pLiveChar->id;
		/**/
		if( pLiveChar->id == (TEP_CHARACTER | CHAR_SHEROESHA) )
		{
			iLocalCount = iLocalCount;
		}
		++iLocalCount;

		/* Get the trust index */
		*(LiveList + iLocalCount) = pLiveChar->like;
		++iLocalCount;

		/* Get the complimentCounter */
		*(LiveList + iLocalCount) = pLiveChar->complimentCounter;
		++iLocalCount;

		/* Get the number of suspicion indices of a given character  */
		for (whackP = pLiveChar->whacklist, suspicionCount = 0; whackP != NULL  ; ++suspicionCount, whackP = whackP->NEXT)
		{
			;
		}
		/* Record the number of suspicion indices */
		*(LiveList + iLocalCount) = suspicionCount;
		++iLocalCount;
		/* Record the suspicion index of the character, in order */
		for (whackP = pLiveChar->whacklist; whackP != NULL; whackP = whackP->NEXT)
		{
			*(LiveList + iLocalCount) = whackP->value;
			++iLocalCount;
			*(LiveList + iLocalCount) = whackP->character;
			++iLocalCount;
		}

		/* FROST!!! you set clueAttached to pGameState->liveList->clues - that's only ever going to grab the first character's clues...
			clue attached was never incremented to the next node either... infinite loop if the first character ever had a clue attached */
		/* Get the number of attached clues to the character */
		for (iNumClues = 0, clueAttached = pLiveChar->clues; clueAttached != NULL; ++iNumClues, clueAttached = clueAttached->NEXT)
		{
			;
		}
		/* Record the number of attached clues */
		*(LiveList + iLocalCount) = iNumClues;
		++iLocalCount;
		/* Record the IDs of any and all attached clues for this character */
		for (clueAttached = pLiveChar->clues; clueAttached != NULL; clueAttached = clueAttached->NEXT)
		{
			*(LiveList + iLocalCount) = clueAttached->NODE;
			++iLocalCount;
		}

	}


	if ( fnHeaderWrite(stream, "LILT", iLocalCount, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (anotherLocalCount = 0; anotherLocalCount < iLocalCount; ++anotherLocalCount)
	{
		if ( (fwrite(&LiveList[anotherLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write LILT to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(LiveList);

	return TRUE;
}

/* Character's name data */
BOOL fnSaveNAME(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	//This is not, and probably won't be, implemented.

	return TRUE;
}

/* Evidence Against data */
/* For each clue, the first unsigned long delineates the ID of the clue; the second unsigned long delineates the character
	the third is the id of the location or character where the clue was found */
/* the clue is attached to (i.e. the clue is against this character) */
BOOL fnSaveEVAG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	TepPlayerEvidence *pEvidence = gameState->player->evidenceGeneric;
	unsigned long *EvidenceAgainstList;			/* The clue ID, followed by the ID of the character it's attached to */
	int iNumEvidenceAgainst;					/* The number of evidence against a character */


	/* Get the number of clues in the evidence against list */
	for (iNumEvidenceAgainst = 0; pEvidence != NULL  ; ++iNumEvidenceAgainst, pEvidence = pEvidence->NEXT)
	{
		;
	}
	EvidenceAgainstList = calloc(iNumEvidenceAgainst*3, sizeof(unsigned long));	/* Times two for twice the integer goodness */


	/* Get the tepIDs of each clue in the list and the tepID of each character a given clue is attached to */
	for ( pEvidence = gameState->player->evidenceGeneric, iLocalCount = 0; iLocalCount < iNumEvidenceAgainst*3; pEvidence = pEvidence->NEXT)
	{
		*(EvidenceAgainstList + iLocalCount) = pEvidence->clue;
		++iLocalCount;
		*(EvidenceAgainstList + iLocalCount) = pEvidence->attachedTo;
		++iLocalCount;
		*(EvidenceAgainstList + iLocalCount) = pEvidence->whereFound;
		++iLocalCount;
	}

	if ( fnHeaderWrite(stream, "EVAG", iNumEvidenceAgainst*3, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumEvidenceAgainst*3; ++iLocalCount)
	{
		if ( (fwrite(&EvidenceAgainstList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write EVAG to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(EvidenceAgainstList);

	return TRUE;
}

/* Evidence Generic data */
BOOL fnSaveEVGE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *EvidenceGenericList;


	/* This has been struck from the game */
	int iNumEvidenceGeneric = 0;
	EvidenceGenericList = calloc(iNumEvidenceGeneric, sizeof(unsigned long));


	/* 	/* This has been struck from the game */
	for (iLocalCount = 0; iLocalCount < iNumEvidenceGeneric; ++iLocalCount)
	{
		*(EvidenceGenericList + iLocalCount) = 668 + iLocalCount;
	}

	if ( fnHeaderWrite(stream, "EVGE", iNumEvidenceGeneric, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumEvidenceGeneric; ++iLocalCount)
	{
		if ( (fwrite(&EvidenceGenericList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write EVGE to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(EvidenceGenericList);

	return TRUE;
}

/* Old Evidence Against */
BOOL fnSaveOEVA(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *OldEvidenceAgainstList;


	/* 	/* This has been struck from the game */
	int iNumOldEvidenceAgainst = 0;
	OldEvidenceAgainstList = calloc(iNumOldEvidenceAgainst, sizeof(unsigned long));


	/* This has been struck from the game */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceAgainst; ++iLocalCount)
	{
		*(OldEvidenceAgainstList + iLocalCount) = 3200 + iLocalCount;
	}

	if ( fnHeaderWrite(stream, "OEVA", iNumOldEvidenceAgainst, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceAgainst; ++iLocalCount)
	{
		if ( (fwrite(&OldEvidenceAgainstList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write OEVA to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(OldEvidenceAgainstList);

	return TRUE;
}

/* Old Evidence Generic */
BOOL fnSaveOEVG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *OldEvidenceGenericList;


	/* This has been struck from the game */
	int iNumOldEvidenceGeneric = 0;
	OldEvidenceGenericList = calloc(iNumOldEvidenceGeneric, sizeof(unsigned long));


	/* This has been struck from the game */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceGeneric; ++iLocalCount)
	{
		*(OldEvidenceGenericList + iLocalCount) = 668 + iLocalCount;
	}

	if ( fnHeaderWrite(stream, "OEVG", iNumOldEvidenceGeneric, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumOldEvidenceGeneric; ++iLocalCount)
	{
		if ( (fwrite(&OldEvidenceGenericList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write OEVG to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(OldEvidenceGenericList);

	return TRUE;
}

/* Current Victim */
BOOL fnSaveCUVI(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *CurrentVictimList;


	/* Get the number of characters on the killers list */
	int iNumCurrentVictims = 4;
	CurrentVictimList = calloc(iNumCurrentVictims, sizeof(unsigned long));


	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0; iLocalCount < iNumCurrentVictims; ++iLocalCount)
	{
		*(CurrentVictimList + iLocalCount) = 668 + iLocalCount;
	}

	if ( fnHeaderWrite(stream, "CUVI", iNumCurrentVictims, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumCurrentVictims; ++iLocalCount)
	{
		if ( (fwrite(&CurrentVictimList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write CUVI to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(CurrentVictimList);

	return TRUE;
}

/* This really refers to a bunch of murder data.  The first integer is the id of the murderer.  The second integer is the id of the victim. */
BOOL fnSaveCUMU(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;				/* A generic counter */
	unsigned long *CurrentMurderList;
	TepCurMurder *murderP;				/* Pointer to the relevant struct */
	int iNumCurrentMurder = 0;			/* Number of murders in the list */


	murderP = gameState->currentMurder;			/* Point to the first murder */

	/* Get the number of murders in the list */
	for (iNumCurrentMurder = 0; murderP != NULL  ; ++iNumCurrentMurder, murderP = murderP->NEXT)
	{
		;
	}
	CurrentMurderList = calloc(iNumCurrentMurder*2, sizeof(unsigned long));		/* Two integers per item */
	murderP = gameState->currentMurder;			/* Point to the first murder */


	/* Get the IDs of each murderer, then victim, in the order of the deaths */
	for (iLocalCount = 0; iLocalCount < iNumCurrentMurder; ++iLocalCount, murderP = murderP->NEXT)
	{
		/* Store the id of the murderer */
		*(CurrentMurderList + iLocalCount) = murderP->murderer;
		++iLocalCount;
		/* Store the id of the victim */
		*(CurrentMurderList + iLocalCount) = murderP->victim;
	}

	if ( fnHeaderWrite(stream, "CUMU", iNumCurrentMurder*2, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumCurrentMurder*2; ++iLocalCount)
	{
		if ( (fwrite(&CurrentMurderList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write CUMU to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(CurrentMurderList);

	return TRUE;
}

/* Current Deaths data */
BOOL fnSaveCUDE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *CurrentDeathsList;


	/* Get the number of characters on the killers list */
	int iNumCurrentDeaths = 4;
	CurrentDeathsList = calloc(iNumCurrentDeaths, sizeof(unsigned long));


	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0; iLocalCount < iNumCurrentDeaths; ++iLocalCount)
	{
		*(CurrentDeathsList + iLocalCount) = 668 + iLocalCount;
	}

	if ( fnHeaderWrite(stream, "CUDE", iNumCurrentDeaths, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumCurrentDeaths; ++iLocalCount)
	{
		if ( (fwrite(&CurrentDeathsList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write CUDE to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(CurrentDeathsList);

	return TRUE;
}

/* Room ID */
BOOL fnSaveROID(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	unsigned long *RoomIDList;


	/* Get the number of characters on the killers list */
	int iNumRoomID = 4;
	RoomIDList = calloc(iNumRoomID, sizeof(unsigned long));


	/* Get the tepIDs of each character on the killers list */
	for (iLocalCount = 0; iLocalCount < iNumRoomID; ++iLocalCount)
	{
		*(RoomIDList + iLocalCount) = 668 + iLocalCount;
	}

	if ( fnHeaderWrite(stream, "ROID", iNumRoomID, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumRoomID; ++iLocalCount)
	{
		if ( (fwrite(&RoomIDList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write ROID to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(RoomIDList);

	return TRUE;
}

/* Room People data */
/* For each piece of data, the first unsigned long is the ID of a character.  The second unsigned long is the ID of the  */
/* room that character is currently in. */
BOOL fnSaveROPE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	int anotherLocalCount = 0;		/* Another generic counter */
	int iNumRoomPeople;
	TepDynRoom *pDynRoom = gameState->mapLite;
	TepChar *pLiveList = gameState->liveList;
	unsigned long *RoomPeopleList;


	/* Get the number of live characters */
	for (iNumRoomPeople = 0; pLiveList != NULL  ; ++iNumRoomPeople, pLiveList = pLiveList->NEXT)
	{
		;
	}
	RoomPeopleList = calloc(iNumRoomPeople*2, sizeof(unsigned long));


	/* For each character, get the tepID of a character followed by the tepID of the room that character currently occupies 
	for (iLocalCount = 0; iLocalCount < iNumRoomPeople*2; ++iLocalCount, pLiveList = pLiveList->NEXT)
	{
		*(RoomPeopleList + iLocalCount) = gameState->mapLite->people;
		++iLocalCount;
		pLiveList = pLiveList->NEXT;
		*(RoomPeopleList + iLocalCount) = gameState->player->evidenceGeneric->attachedTo;
	}*/

	/* loop through the dynamic map... */
	for( iLocalCount = 0; iLocalCount < iNumRoomPeople*2, pDynRoom != NULL; pDynRoom = pDynRoom->NEXT )
	{
		TepIDUnNode *pPeepList = pDynRoom->people;
		/* loop through the people list on each dyn room */
		for(; pPeepList != NULL; pPeepList = pPeepList->NEXT)
		{
			*(RoomPeopleList + iLocalCount) = pPeepList->NODE;
			++iLocalCount;
			*(RoomPeopleList + iLocalCount) = pDynRoom->asRoomID;
			iLocalCount++;
		}
	}

	if ( fnHeaderWrite(stream, "ROPE", iNumRoomPeople*2, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}

	/* Write the actual data */
	for (anotherLocalCount = 0; anotherLocalCount < iLocalCount; ++anotherLocalCount)
	{
		if ( (fwrite(&RoomPeopleList[anotherLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write ROPE to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(RoomPeopleList);

	return TRUE;
}

/* Room Object data.  For each object, first integer is the object ID, second integer is the room ID the object resides in. */
BOOL fnSaveROBJ(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState)
{
	int iLocalCount = 0;			/* A generic counter */
	TepIDUnNode *pObject;
	TepDynRoom *pDynRoom;
	unsigned long *RoomObjectList;
	int iNumObjects;				/* The number of objects */


	/* Point to the first dynamic room in the list */
	/* Get the number of objects */
	for (iNumObjects = 0, pDynRoom = gameState->mapLite; pDynRoom != NULL; pDynRoom = pDynRoom->NEXT)
	{
		for (pObject = pDynRoom->objs; pObject != NULL; pObject = pObject->NEXT)
		{
			++iNumObjects;
			++iNumObjects;
		}
	}	

	/* Allocate that memory! */
	RoomObjectList = calloc(iNumObjects, sizeof(unsigned long));
	/* Blow through each room's linked list */
	for (pDynRoom = gameState->mapLite; pDynRoom != NULL; pDynRoom = pDynRoom->NEXT)
	{
		for (pObject = pDynRoom->objs; pObject != NULL; pObject = pObject->NEXT)
		{
			*(RoomObjectList + iLocalCount) = pObject->NODE;			
			++iLocalCount;
			*(RoomObjectList + iLocalCount) = pDynRoom->asRoomID;			
			++iLocalCount;
		}
	}


	if ( fnHeaderWrite(stream, "ROBJ", iNumObjects, iFileOffset) == FALSE)
	{
		printf("fnHeaderWrite failed.\n");
		return FALSE;
	}


	/* Write the actual data */
	for (iLocalCount = 0; iLocalCount < iNumObjects; ++iLocalCount)
	{
		if ( (fwrite(&RoomObjectList[iLocalCount], sizeof(unsigned long), 1, stream)) != 1 )
		{
			printf("Failed to write ROBJ to file!\n");
			return FALSE;
		}
		*iFileOffset += sizeof(unsigned long);
	}


	/* Cleanup */
	free(RoomObjectList);

	return TRUE;
}
