#include "tep_incs.h"
#include "characterdefines.h"


/* Programmer Name: Nathaniel Cleveland
 * Date Created: Feb 7th, 2000
 * Program Updated by:
 *
 * Program Description:         Randomly selects a character then prints out that character's introduction speach.
 *
 * Program dependacies:         "tep_incs.h", fnStoryIntro_RandChar(), fnPrintOut, fnTepCharSearch, fnTepConvDataSearch
 * Takes:                       void
 * Gives:                       The BOOL value FAILURE (-1), if it doesn't work
 *                              BOOL value TRUE, if it does.
 */


/*******************************************************************************/
/*******************************************************************************/
/***************************** Debug Stuff *************************************/
/*******************************************************************************/
/*******************************************************************************/
/*
TepChar Rushi;
TepChar Totok;
TepChar Coman;

TepConvData ConvRushi;
TepConvData ConvTotok;
TepConvData ConvComan;

void Tep_RandSeed(void);

void fnSetGlobals(void)
{
    Tep_RandSeed();

    Rushi.name = "Rushi";
    Rushi.id = TEP_CHARACTER + 1;
    Rushi.conv = &ConvRushi;
    Rushi.NEXT = &Totok;

    Totok.name = "Totok";
    Totok.id = TEP_CHARACTER + 2;
    Totok.conv = &ConvTotok;
    Totok.NEXT = &Coman;

    Coman.name = "Coman";
    Coman.id = TEP_CHARACTER + 3;
    Coman.conv = &ConvComan;
    Coman.NEXT = NULL;

    ConvRushi.details = "My name is Rushi, I'm drunk as hell.";
    ConvTotok.details = "Don't be mean to Tooootok!";
    ConvComan.details = "I'm Coman, do you want a gourd.";
}



*/

/********************* LIST FUNCTION ************************/
/*FUNCTION:     fnTepCharSearch
 *PARAMETERS:   TepChar                 *pListRoot  Used as the starting point for the list search
 *              TepID                   searchID    Search for this parameter
 *RETURN VALUE: Pointer to the node in the list that the search matches
 *SIDE EFFECTS: None
 *DESCRIPTION:  This function searches for a node in the list corresponding to the given node pointer.
*/
/*
TepChar* fnTepCharSearch(TepChar *pListRoot, TepID searchID)
{
    TepChar *pCurrNode;

    for(pCurrNode = pListRoot; pCurrNode != NULL; pCurrNode = pCurrNode->NEXT)
    {
        if((pCurrNode->id) == searchID)
        {
            return pCurrNode;
        }
    }

    return NULL;
}


/**** TEP CONV DATA *****************************/

/*FUNCTION:     fnTepConvDataSearch
 *PARAMETERS:   TepConvData             *pListRoot  Used as the starting point for the list search
 *              TepID                   searchID    Search for this parameter
 *RETURN VALUE: Pointer to the node in the list that the search matches
 *SIDE EFFECTS: None
 *DESCRIPTION:  This function searches for a node in the list corresponding to the given node pointer.
*/
/*
TepConvData *fnTepConvDataSearch(TepConvData *pListRoot, TepID searchID)
{
    TepConvData *pCurrNode;

    for(pCurrNode = pListRoot; pCurrNode != NULL; pCurrNode = pCurrNode->NEXT)
    {
        if((pCurrNode->id) == searchID)
        {
            return pCurrNode;
        }
    }
    return NULL;
}

/*******************************************************************************/
/*******************************************************************************/
/*************************** End Debug Stuff ***********************************/
/*******************************************************************************/
/*******************************************************************************/


BOOL fnStoryIntroduction(TepCurState *pGameState)
{
    //TepID       ID_ChosenChar = 0;                      /* id of the chosen one */
    TepChar     *pTep_Char = NULL;                      /* pointer the the character's info struct */
    TepConvData *pTep_Conv = NULL;                      /* pointer to a character's intro speech */

/********************** Debug function call *****************/
//  fnSetGlobals();                         /* Debug Function that seeds the rand for RandChar */
/***********************************************************/
	
	/* find the generic intro */
    pTep_Conv = fnTepConvDataSearch(pGameState->genConv, TEP_TALK | TALK_BOGINTRODUCTION, 0);
	if( pTep_Conv == NULL )
	{
		printf("Unable to find the text for the generic story intro.\n");
		return FALSE;
	}

    /* Print out what we have */
    fnPrintOut(PAUSE, NULL,NULL,1, pTep_Conv->details);



    /* randomly generate a character's ID with fnStoryIntro_RandChar()*/
    pTep_Char = fnPickRandGoodChar( pGameState ); //fnStoryIntro_RandChar();

    /* pass the ID I made and get back a pointer to it's struct */
    //pTep_Char = fnTepCharSearch(pGameState->liveList, ID_ChosenChar);
	if( pTep_Char != NULL )
	{
		//printf("%s will give the intro speech.\n", pTep_Char->name);
	}
	else
	{
		printf("Unable to choose a character for the story intro.\n");
		return FALSE;
	}

    /* find the actual conversation I need to print. I'll pass talk or'd with init which i think is intro */
    pTep_Conv = fnTepConvDataSearch(pTep_Char->conv, TEP_TALK | TALK_BOGINTROSPEECH, 0);
	if( pTep_Conv == NULL )
	{
		printf("Unable to find the text for the story intro.\n");
		return FALSE;
	}

    /* Print out what we have */
    fnPrintOut(PAUSE, NULL,NULL,1, pTep_Conv->details);


    
	/* find Sheroesha */
    pTep_Char = fnTepCharSearch(pGameState->liveList, TEP_CHARACTER | CHAR_SHEROESHA);
	if( pTep_Char == NULL )
	{
		printf("Unable to find Sheroesha for the story intro.\n");
		return FALSE;
	}

	/* find sheroesha's generic intro */
    pTep_Conv = fnTepConvDataSearch(pTep_Char->conv, TEP_TALK | TALK_BOGSHEROESHASPEAKS, 0);
	if( pTep_Conv == NULL )
	{
		printf("Unable to find the text for sheroesha's story intro.\n");
		return FALSE;
	}

    /* Print out what we have */
    fnPrintOut(PAUSE, NULL,NULL,1, pTep_Conv->details);

	printf( "\n\n" );


    return TRUE;
}


/* randomly get an ID number for a character */
TepID fnStoryIntro_RandChar(void)
{
        /* Take a random number, % by the Number of characters in the game, or that with TEP_CHARACTER */
        /*  voila, we have a random character selection. Return that number to the calling function*/
    return  (TepID)(TEP_CHARACTER + (rand() % NUMBER_OF_CHARACTERS) + 1);
}



/***** Debug Main *****/
/*
int main()
{
    BOOL ReturnBool;
    char inputArray[255];
    TepCurState GameState;

    while(1)
    {
        gets(inputArray);
        ReturnBool = fnStoryIntroduction(&GameState);
    }

    return 0;
}
*/
